
#line 3 "lex.zz.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;
#endif /* ! C99 */

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define zzconst const
#else
#define zzconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (zz_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((zz_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE zzrestart(zzin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#define YY_BUF_SIZE 16384
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(zz_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct zz_buffer_state *YY_BUFFER_STATE;
#endif

extern int zzleng;

extern FILE *zzin, *zzout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    /* Note: We specifically omit the test for zz_rule_can_match_eol because it requires
     *       access to the local variable zz_act. Since zzless() is a macro, it would break
     *       existing scanners that call zzless() from OUTSIDE zzlex. 
     *       One obvious solution it to make zz_act a global. I tried that, and saw
     *       a 5% performance hit in a non-zzlineno scanner, because zz_act is
     *       normally declared as a register variable-- so it is not worth it.
     */
    #define  YY_LESS_LINENO(n) \
            do { \
                int zzl;\
                for ( zzl = n; zzl < zzleng; ++zzl )\
                    if ( zztext[zzl] == '\n' )\
                        --zzlineno;\
            }while(0)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define zzless(n) \
	do \
		{ \
		/* Undo effects of setting up zztext. */ \
        int zzless_macro_arg = (n); \
        YY_LESS_LINENO(zzless_macro_arg);\
		*zz_cp = (zz_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(zz_c_buf_p) = zz_cp = zz_bp + zzless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up zztext again */ \
		} \
	while ( 0 )

#define unput(c) zzunput( c, (zztext_ptr)  )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t zz_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct zz_buffer_state
	{
	FILE *zz_input_file;

	char *zz_ch_buf;		/* input buffer */
	char *zz_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	zz_size_t zz_buf_size;

	/* Number of characters read into zz_ch_buf, not including EOB
	 * characters.
	 */
	int zz_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int zz_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int zz_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int zz_at_bol;

    int zz_bs_lineno; /**< The line count. */
    int zz_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int zz_fill_buffer;

	int zz_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via zzrestart()), so that the user can continue scanning by
	 * just pointing zzin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t zz_buffer_stack_top = 0; /**< index of top of stack. */
static size_t zz_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * zz_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (zz_buffer_stack) \
                          ? (zz_buffer_stack)[(zz_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (zz_buffer_stack)[(zz_buffer_stack_top)]

/* zz_hold_char holds the character lost when zztext is formed. */
static char zz_hold_char;
static int zz_n_chars;		/* number of characters read into zz_ch_buf */
int zzleng;

/* Points to current character in buffer. */
static char *zz_c_buf_p = (char *) 0;
static int zz_init = 0;		/* whether we need to initialize */
static int zz_start = 0;	/* start state number */

/* Flag which is used to allow zzwrap()'s to do buffer switches
 * instead of setting up a fresh zzin.  A bit of a hack ...
 */
static int zz_did_buffer_switch_on_eof;

void zzrestart (FILE *input_file  );
void zz_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE zz_create_buffer (FILE *file,int size  );
void zz_delete_buffer (YY_BUFFER_STATE b  );
void zz_flush_buffer (YY_BUFFER_STATE b  );
void zzpush_buffer_state (YY_BUFFER_STATE new_buffer  );
void zzpop_buffer_state (void );

static void zzensure_buffer_stack (void );
static void zz_load_buffer_state (void );
static void zz_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER zz_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE zz_scan_buffer (char *base,zz_size_t size  );
YY_BUFFER_STATE zz_scan_string (zzconst char *zz_str  );
YY_BUFFER_STATE zz_scan_bytes (zzconst char *bytes,int len  );

void *zzalloc (zz_size_t  );
void *zzrealloc (void *,zz_size_t  );
void zzfree (void *  );

#define zz_new_buffer zz_create_buffer

#define zz_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        zzensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            zz_create_buffer(zzin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->zz_is_interactive = is_interactive; \
	}

#define zz_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        zzensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            zz_create_buffer(zzin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->zz_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->zz_at_bol)

/* Begin user sect3 */

typedef unsigned char YY_CHAR;

FILE *zzin = (FILE *) 0, *zzout = (FILE *) 0;

typedef int zz_state_type;

#define YY_FLEX_LEX_COMPAT
extern int zzlineno;

int zzlineno = 1;

extern char zztext[];

static zz_state_type zz_get_previous_state (void );
static zz_state_type zz_try_NUL_trans (zz_state_type current_state  );
static int zz_get_next_buffer (void );
static void zz_fatal_error (zzconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up zztext.
 */
#define YY_DO_BEFORE_ACTION \
	(zztext_ptr) = zz_bp; \
	zzleng = (size_t) (zz_cp - zz_bp); \
	(zz_hold_char) = *zz_cp; \
	*zz_cp = '\0'; \
	if ( zzleng + (zz_more_offset) >= YYLMAX ) \
		YY_FATAL_ERROR( "token too large, exceeds YYLMAX" ); \
	zz_flex_strncpy( &zztext[(zz_more_offset)], (zztext_ptr), zzleng + 1 ); \
	zzleng += (zz_more_offset); \
	(zz_prev_more_offset) = (zz_more_offset); \
	(zz_more_offset) = 0; \
	(zz_c_buf_p) = zz_cp;

#define YY_NUM_RULES 55
#define YY_END_OF_BUFFER 56
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct zz_trans_info
	{
	flex_int32_t zz_verify;
	flex_int32_t zz_nxt;
	};
static zzconst flex_int16_t zz_acclist[248] =
    {   0,
       52,   51,   52,   56,   54,   55,   52,   54,   55,   53,
       55,   45,   54,   55,   44,   54,   55,   54,   55,   54,
       55,   50,   54,   55,   54,   55,   54,   55,   48,   54,
       55,   48,   54,   55,   48,   54,   55,   48,   54,   55,
       48,   54,   55,   48,   54,   55,   48,   54,   55,   48,
       54,   55,   48,   54,   55,   48,   54,   55,   48,   54,
       55,   48,   54,   55,   48,   54,   55,   48,   54,   55,
       48,   54,   55,   48,   54,   55,   51,   52,   54,   55,
        3,   55,    2,    3,   55,    4,   55,    3,   55,   52,
       44,   43,   42,   38,   50,   50,   41,   39,   40,   48,

       48,   48,   20,   48,   48,   16,   48,   48,   48,   48,
       48,   48,   48,    5,   48,   48,   21,   48,   48,   48,
       48,   48,   22,   48,   17,   48,   10,   48,   48,   48,
       48,   48,   48,   19,   48,   48,   48,   51,   52,    2,
       50,   50,   49,    8,   48,   48,   48,   13,   48,   48,
       48,   18,   48,   48,   48,   48,   48,   48,   48,   33,
       48,    9,   48,   48,   48,   48,   48,   48,   48,   48,
       48,   48,   48,   23,   48,    7,   48,   48,   48,   48,
       48,   48,   48,   48,   27,   48,   48,   48,   48,   48,
       32,   48,   31,   48,    6,   48,   48,   28,   48,   48,

       48,   48,   48,   48,   48,   48,   48,   48,   48,   48,
       48,   26,   48,   14,   48,   36,   48,   30,   48,   48,
       15,   48,   35,   48,   48,   48,   34,   48,   48,   25,
       48,   12,   48,   48,   29,   48,   37,   48,   11,   48,
       48,   24,   48,    1,    1,   47,   46
    } ;

static zzconst flex_int16_t zz_accept[200] =
    {   0,
        1,    2,    4,    4,    4,    5,    7,   10,   12,   15,
       18,   20,   22,   25,   27,   29,   32,   35,   38,   41,
       44,   47,   50,   53,   56,   59,   62,   65,   68,   71,
       74,   77,   81,   83,   86,   88,   90,   91,   92,   93,
       94,   95,   96,   97,   97,   98,   99,  100,  101,  102,
      103,  105,  106,  108,  109,  110,  111,  112,  113,  114,
      116,  117,  119,  120,  121,  122,  123,  125,  127,  129,
      130,  131,  132,  133,  134,  136,  137,  138,  140,  141,
      141,  142,  142,  143,  143,  143,  144,  146,  147,  148,
      150,  151,  152,  154,  155,  156,  157,  158,  159,  160,

      162,  164,  165,  166,  167,  168,  169,  170,  171,  172,
      173,  174,  174,  174,  174,  176,  178,  179,  180,  181,
      182,  183,  184,  185,  187,  188,  189,  190,  191,  193,
      195,  197,  198,  200,  201,  201,  201,  201,  202,  203,
      204,  205,  206,  207,  208,  209,  210,  211,  212,  214,
      216,  216,  216,  216,  218,  220,  221,  223,  225,  226,
      227,  229,  230,  232,  234,  234,  234,  234,  235,  237,
      237,  238,  239,  239,  239,  239,  241,  242,  242,  242,
      242,  244,  244,  244,  244,  245,  245,  245,  246,  246,
      246,  246,  247,  247,  247,  247,  247,  248,  248

    } ;

static zzconst flex_int32_t zz_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    1,    4,    5,    1,    1,    1,    6,    1,
        1,    7,    8,    1,    9,   10,    1,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   12,    1,   13,
       14,   15,    1,    1,   16,   16,   16,   16,   17,   16,
       16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
       16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
        1,    1,    1,    1,   16,    1,   18,   19,   20,   21,

       22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
       32,   33,   16,   34,   35,   36,   37,   16,   38,   39,
       40,   16,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static zzconst flex_int32_t zz_meta[41] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        2,    1,    1,    1,    1,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2
    } ;

static zzconst flex_int16_t zz_base[203] =
    {   0,
        0,  357,   39,   41,  358,  360,  355,  360,  360,  353,
      348,  339,   35,   33,  339,  341,   38,   39,   40,   42,
       44,   45,   43,   55,   48,   65,   70,   49,   77,   53,
       83,  349,  360,  348,  360,  318,  346,  344,  360,  360,
      360,  100,  103,   59,  360,  360,  360,    0,  335,   79,
      334,   81,  333,   92,  107,   96,   85,  110,   94,  332,
       54,  113,  112,  119,  120,  123,  331,  330,  329,  124,
      125,  127,  126,  129,  328,  128,  141,  336,  335,  315,
      143,  324,  158,  323,  162,  322,  321,  135,  155,  320,
      142,  161,  319,  165,  167,  168,  170,  171,  173,  318,

      317,  176,  179,  180,  177,  181,  178,  182,  184,  185,
      183,  325,  315,  314,  313,  312,  192,  193,  194,  197,
      200,  206,  207,  311,  208,  210,  211,  212,  310,  309,
      308,  213,  307,  209,  223,  308,  305,  221,  222,  224,
      225,  226,  230,  234,  228,  229,  236,  237,  304,  303,
      282,  301,  300,  299,  298,  241,  297,  296,  244,  258,
      295,  248,  294,  293,  274,  291,  289,  247,  289,  268,
      360,  252,  273,  287,  286,  285,  254,  264,  283,  282,
      281,  264,  274,  272,  281,  271,  270,  278,  270,  266,
      264,  360,  148,  138,  134,  132,  360,  360,  287,  289,

       96,   60
    } ;

static zzconst flex_int16_t zz_def[203] =
    {   0,
      198,    1,  199,  199,  198,  198,  198,  198,  198,  200,
      198,  198,  198,  198,  198,  201,  201,  201,  201,  201,
      201,  201,  201,  201,  201,  201,  201,  201,  201,  201,
      201,  198,  198,  198,  198,  198,  198,  200,  198,  198,
      198,  198,  198,  198,  198,  198,  198,  202,  201,  201,
      201,  201,  201,  201,  201,  201,  201,  201,  201,  201,
      201,  201,  201,  201,  201,  201,  201,  201,  201,  201,
      201,  201,  201,  201,  201,  201,  201,  198,  198,  198,
      198,  198,  198,  198,  198,  198,  201,  201,  201,  201,
      201,  201,  201,  201,  201,  201,  201,  201,  201,  201,

      201,  201,  201,  201,  201,  201,  201,  201,  201,  201,
      201,  198,  198,  198,  201,  201,  201,  201,  201,  201,
      201,  201,  201,  201,  201,  201,  201,  201,  201,  201,
      201,  201,  201,  201,  198,  198,  198,  201,  201,  201,
      201,  201,  201,  201,  201,  201,  201,  201,  201,  201,
      198,  198,  198,  201,  201,  201,  201,  201,  201,  201,
      201,  201,  201,  201,  198,  198,  198,  201,  201,  198,
      198,  201,  198,  198,  198,  201,  201,  198,  198,  198,
      201,  198,  198,  198,  198,  198,  198,  198,  198,  198,
      198,  198,  198,  198,  198,  198,  198,    0,  198,  198,

      198,  198
    } ;

static zzconst flex_int16_t zz_nxt[401] =
    {   0,
        6,    7,    8,    9,   10,    9,   11,    6,   12,    6,
       13,    6,   14,    6,   15,   16,   16,   17,   18,   19,
       20,   21,   22,   23,   16,   24,   16,   16,   25,   16,
       26,   27,   16,   28,   16,   29,   30,   31,   16,   16,
       34,   35,   34,   35,   42,   43,   45,   46,   48,   48,
       48,   44,   48,   48,   48,   48,   44,   52,   48,   48,
       36,   48,   36,   48,   48,   48,   85,   85,   50,   86,
       71,   59,   54,   53,   55,   48,   57,   60,   51,   63,
       48,   58,   56,   76,   61,   62,   96,   48,   66,   48,
       64,   48,   67,   48,   72,   48,   65,   49,   73,   87,

       68,   74,   48,   69,   48,   70,   48,   77,   75,   42,
       81,   82,   42,   83,   84,   88,   44,   48,   93,   44,
       48,   44,   48,   48,   44,   95,   89,   90,   91,   48,
       48,   92,   97,   48,   48,   48,   48,   48,   48,   48,
       94,   98,  197,   99,  196,   48,  195,  100,  103,  102,
      108,   48,   48,   81,  107,  101,  115,  104,  194,   44,
      105,  106,  110,  109,   44,   48,  111,   42,   83,   85,
       85,   48,   86,  117,   44,   48,  116,   48,   48,   44,
       48,   48,  118,   48,  119,  120,   48,   48,   48,   48,
       48,   48,   48,   48,   48,   48,  123,  125,  122,  121,

      126,  127,   48,   48,   48,  124,  130,   48,  129,  132,
       48,  134,  131,  128,  141,  133,   48,   48,   48,   48,
       48,   48,   48,   48,  135,  138,  139,  145,  147,  140,
      150,   48,   48,  142,   48,   48,   48,  144,   48,   48,
       48,  149,  143,  146,   48,  148,   48,   48,  151,  156,
      159,   48,  155,  157,   48,  160,  154,   48,   48,  170,
      171,  158,   48,  161,   48,  169,  162,  164,   48,  170,
      171,  163,  168,  172,  193,  181,  192,  176,  191,  188,
      190,  189,  188,  187,  186,  185,  177,   33,   33,   38,
       38,   48,  184,  183,  182,   48,  180,  179,  178,   48,

      175,  174,  173,   48,   48,   48,   48,   48,   48,   48,
      167,  166,  165,   48,   48,  153,  152,   48,   48,   48,
       48,   48,   48,   48,  137,  136,  135,   48,   48,   48,
       48,   48,   86,  114,  113,  112,   79,   78,   48,   48,
       48,   48,   48,   48,   48,   48,   39,   37,   80,   79,
       78,   48,   47,   41,   40,   39,   37,  198,   32,    5,
      198,  198,  198,  198,  198,  198,  198,  198,  198,  198,
      198,  198,  198,  198,  198,  198,  198,  198,  198,  198,
      198,  198,  198,  198,  198,  198,  198,  198,  198,  198,
      198,  198,  198,  198,  198,  198,  198,  198,  198,  198

    } ;

static zzconst flex_int16_t zz_chk[401] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        3,    3,    4,    4,   13,   13,   14,   14,   17,   18,
       19,   13,   20,   23,   21,   22,   13,   19,   25,   28,
        3,  202,    4,   30,   61,   24,   44,   44,   17,   44,
       28,   23,   21,   20,   21,   26,   22,   24,   18,   25,
       27,   22,   21,   30,   24,   24,   61,   29,   27,   50,
       26,   52,   27,   31,   29,   57,   26,  201,   29,   50,

       27,   29,   54,   27,   59,   27,   56,   31,   29,   42,
       42,   43,   43,   43,   43,   52,   42,   55,   57,   43,
       58,   42,   63,   62,   43,   59,   54,   55,   56,   64,
       65,   56,   62,   66,   70,   71,   73,   72,   76,   74,
       58,   62,  196,   63,  195,   88,  194,   64,   70,   66,
       74,   77,   91,   81,   73,   65,   88,   71,  193,   81,
       71,   72,   77,   76,   81,   89,   77,   83,   83,   85,
       85,   92,   85,   91,   83,   94,   89,   95,   96,   83,
       97,   98,   92,   99,   94,   95,  102,  105,  107,  103,
      104,  106,  108,  111,  109,  110,   98,  102,   97,   96,

      103,  104,  117,  118,  119,   99,  107,  120,  106,  109,
      121,  111,  108,  105,  120,  110,  122,  123,  125,  134,
      126,  127,  128,  132,  135,  117,  118,  125,  127,  119,
      134,  138,  139,  121,  140,  141,  142,  123,  145,  146,
      143,  132,  122,  126,  144,  128,  147,  148,  135,  140,
      143,  156,  139,  141,  159,  144,  138,  168,  162,  160,
      160,  142,  172,  145,  177,  159,  146,  148,  160,  170,
      170,  147,  156,  162,  191,  177,  190,  168,  189,  188,
      187,  186,  185,  184,  183,  182,  172,  199,  199,  200,
      200,  181,  180,  179,  178,  176,  175,  174,  173,  169,

      167,  166,  165,  164,  163,  161,  158,  157,  155,  154,
      153,  152,  151,  150,  149,  137,  136,  133,  131,  130,
      129,  124,  116,  115,  114,  113,  112,  101,  100,   93,
       90,   87,   86,   84,   82,   80,   79,   78,   75,   69,
       68,   67,   60,   53,   51,   49,   38,   37,   36,   34,
       32,   16,   15,   12,   11,   10,    7,    5,    2,  198,
      198,  198,  198,  198,  198,  198,  198,  198,  198,  198,
      198,  198,  198,  198,  198,  198,  198,  198,  198,  198,
      198,  198,  198,  198,  198,  198,  198,  198,  198,  198,
      198,  198,  198,  198,  198,  198,  198,  198,  198,  198

    } ;

/* Table of booleans, true if rule could match eol. */
static zzconst flex_int32_t zz_rule_can_match_eol[56] =
    {   0,
0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 
    0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0,     };

extern int zz_flex_debug;
int zz_flex_debug = 0;

static zz_state_type *zz_state_buf=0, *zz_state_ptr=0;
static char *zz_full_match;
static int zz_lp;
#define REJECT \
{ \
*zz_cp = (zz_hold_char); /* undo effects of setting up zztext */ \
zz_cp = (zz_full_match); /* restore poss. backed-over text */ \
++(zz_lp); \
goto find_rule; \
}

static int zz_more_offset = 0;
static int zz_prev_more_offset = 0;
#define zzmore() ((zz_more_offset) = zz_flex_strlen( zztext ))
#define YY_NEED_STRLEN
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET \
	{ \
	(zz_more_offset) = (zz_prev_more_offset); \
	zzleng -= (zz_more_offset); \
	}
#ifndef YYLMAX
#define YYLMAX 8192
#endif

char zztext[YYLMAX];
char *zztext_ptr;
#line 1 "beaul.l"
/***************************** LICENSE START ***********************************

 Copyright 2012 ECMWF and INPE. This software is distributed under the terms
 of the Apache License version 2.0. In applying this license, ECMWF does not
 waive the privileges and immunities granted to it by virtue of its status as
 an Intergovernmental Organization or submit itself to any jurisdiction.

 ***************************** LICENSE END *************************************/
#line 11 "beaul.l"

#include <setjmp.h>
#include <stdarg.h>
static jmp_buf env;
#define exit(a)    jumpexit(a)
#define fprintf    jumpprtf

static void jumpexit(int n)
{
	longjmp(env,1);
}

static void jumpprtf(FILE *f,char *fmt,...)
{
	va_list list;
	char buf[1024];
	int len;
	va_start(list,fmt);
	vsprintf(buf, fmt, list);
	va_end(list);

	len = strlen(buf);
	if(len && buf[len-1] == '\n')
		buf[len-1] = 0;

	zzerror(buf);
}

#define _k(x) (keyword(zztext),(x))
#define _w(x) (plainword(zztext),(x))

static void kword(char *p)
{
    char buf[10];
    int i = 0;

    while(*p)
    {
        switch(*p)
        {
        case ' ':
        case '\t':
            buf[i] = 0;
            if(i) keyword(buf);
            buf[0] = *p;
            buf[1] = 0;
            space(buf);
            i = 0;
            break;

        case '\n':
            buf[i] = 0;
            if(i) keyword(buf);
            cr(buf);
            i = 0;
            break;

        default:
            buf[i++] = *p;
            break;
        }
        p++;
    }
    buf[i] = 0;
    keyword(buf);
}

#line 752 "lex.zz.c"

#define INITIAL 0
#define SOURCE 1

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int zz_init_globals (void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int zzlex_destroy (void );

int zzget_debug (void );

void zzset_debug (int debug_flag  );

YY_EXTRA_TYPE zzget_extra (void );

void zzset_extra (YY_EXTRA_TYPE user_defined  );

FILE *zzget_in (void );

void zzset_in  (FILE * in_str  );

FILE *zzget_out (void );

void zzset_out  (FILE * out_str  );

int zzget_leng (void );

char *zzget_text (void );

int zzget_lineno (void );

void zzset_lineno (int line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int zzwrap (void );
#else
extern int zzwrap (void );
#endif
#endif

    static void zzunput (int c,char *buf_ptr  );
    
#ifndef zztext_ptr
static void zz_flex_strncpy (char *,zzconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int zz_flex_strlen (zzconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int zzinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO fwrite( zztext, zzleng, 1, zzout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->zz_is_interactive ) \
		{ \
		int c = '*'; \
		int n; \
		for ( n = 0; n < max_size && \
			     (c = getc( zzin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( zzin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, zzin))==0 && ferror(zzin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(zzin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "zzterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef zzterminate
#define zzterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) zz_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int zzlex (void);

#define YY_DECL int zzlex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after zztext and zzleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( zzleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->zz_at_bol = \
				(zztext[zzleng - 1] == '\n'); \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register zz_state_type zz_current_state;
	register char *zz_cp, *zz_bp;
	register int zz_act;
    
#line 96 "beaul.l"


#line 941 "lex.zz.c"

	if ( !(zz_init) )
		{
		(zz_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

        /* Create the reject buffer large enough to save one state per allowed character. */
        if ( ! (zz_state_buf) )
            (zz_state_buf) = (zz_state_type *)zzalloc(YY_STATE_BUF_SIZE  );
            if ( ! (zz_state_buf) )
                YY_FATAL_ERROR( "out of dynamic memory in zzlex()" );

		if ( ! (zz_start) )
			(zz_start) = 1;	/* first start state */

		if ( ! zzin )
			zzin = stdin;

		if ( ! zzout )
			zzout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			zzensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				zz_create_buffer(zzin,YY_BUF_SIZE );
		}

		zz_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		zz_cp = (zz_c_buf_p);

		/* Support of zztext. */
		*zz_cp = (zz_hold_char);

		/* zz_bp points to the position in zz_ch_buf of the start of
		 * the current run.
		 */
		zz_bp = zz_cp;

		zz_current_state = (zz_start);
		zz_current_state += YY_AT_BOL();

		(zz_state_ptr) = (zz_state_buf);
		*(zz_state_ptr)++ = zz_current_state;

zz_match:
		do
			{
			register YY_CHAR zz_c = zz_ec[YY_SC_TO_UI(*zz_cp)];
			while ( zz_chk[zz_base[zz_current_state] + zz_c] != zz_current_state )
				{
				zz_current_state = (int) zz_def[zz_current_state];
				if ( zz_current_state >= 199 )
					zz_c = zz_meta[(unsigned int) zz_c];
				}
			zz_current_state = zz_nxt[zz_base[zz_current_state] + (unsigned int) zz_c];
			*(zz_state_ptr)++ = zz_current_state;
			++zz_cp;
			}
		while ( zz_base[zz_current_state] != 360 );

zz_find_action:
		zz_current_state = *--(zz_state_ptr);
		(zz_lp) = zz_accept[zz_current_state];
find_rule: /* we branch to this label when backing up */
		for ( ; ; ) /* until we find what rule we matched */
			{
			if ( (zz_lp) && (zz_lp) < zz_accept[zz_current_state + 1] )
				{
				zz_act = zz_acclist[(zz_lp)];
					{
					(zz_full_match) = zz_cp;
					break;
					}
				}
			--zz_cp;
			zz_current_state = *--(zz_state_ptr);
			(zz_lp) = zz_accept[zz_current_state];
			}

		YY_DO_BEFORE_ACTION;

		if ( zz_act != YY_END_OF_BUFFER && zz_rule_can_match_eol[zz_act] )
			{
			int zzl;
			for ( zzl = (zz_prev_more_offset); zzl < zzleng; ++zzl )
				if ( zztext[zzl] == '\n' )
					   
    zzlineno++;
;
			}

do_action:	/* This label is used only to access EOF actions. */

		switch ( zz_act )
	{ /* beginning of action switch */
case 1:
YY_RULE_SETUP
#line 98 "beaul.l"
{ BEGIN INITIAL; kword(zztext); return ENDINLINE;}
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 99 "beaul.l"
space(zztext);
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 100 "beaul.l"
inlineword(zztext);
	YY_BREAK
case 4:
/* rule 4 can match eol */
YY_RULE_SETUP
#line 101 "beaul.l"
cr(zztext);
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 103 "beaul.l"
return _k(IF);
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 104 "beaul.l"
return _k(THEN);
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 105 "beaul.l"
return _k(ELSE);
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 106 "beaul.l"
return _k(AND);
	YY_BREAK
case 9:
YY_RULE_SETUP
#line 107 "beaul.l"
return _k(NOT);
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 108 "beaul.l"
return _k(OR);
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 109 "beaul.l"
return _k(FUNCTION);
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 110 "beaul.l"
return _k(RETURN);
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 111 "beaul.l"
return _k(END);
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 112 "beaul.l"
return _k(WHILE);
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 113 "beaul.l"
return _k(GLOBAL);
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 114 "beaul.l"
return _k(DO);
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 115 "beaul.l"
return _k(ON);
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 116 "beaul.l"
return _k(FOR);
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 117 "beaul.l"
return _k(TO);
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 118 "beaul.l"
return _k(BY);
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 119 "beaul.l"
return _k(IN);
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 120 "beaul.l"
return _k(OF);
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 121 "beaul.l"
return _k(CASE);
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 122 "beaul.l"
return _k(OTHERWISE);
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 123 "beaul.l"
return _k(REPEAT);
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 124 "beaul.l"
return _k(UNTIL);
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 125 "beaul.l"
return _k(LOOP);
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 126 "beaul.l"
return _k(WHEN);
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 127 "beaul.l"
return _k(INCLUDE);
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 128 "beaul.l"
return _k(EXTERN);
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 129 "beaul.l"
return _k(TELL);
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 130 "beaul.l"
return _k(TASK);
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 131 "beaul.l"
return _k(NIL);
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 132 "beaul.l"
return _k(OBJECT);
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 133 "beaul.l"
return _k(IMPORT);
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 134 "beaul.l"
return _k(EXPORT);
	YY_BREAK
case 37:
/* rule 37 can match eol */
YY_RULE_SETUP
#line 135 "beaul.l"
{ BEGIN SOURCE; kword(zztext);return INLINE;}
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 138 "beaul.l"
return _w(ARROW);
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 139 "beaul.l"
return _w(NE);
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 140 "beaul.l"
return _w(GE);
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 141 "beaul.l"
return _w(LE);
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 142 "beaul.l"
return _w('^');
	YY_BREAK
case 43:
/* rule 43 can match eol */
YY_RULE_SETUP
#line 144 "beaul.l"
{ zztext[zzleng-1] = 0; comment(zztext);}
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 145 "beaul.l"
comment(zztext);
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 147 "beaul.l"
{ 
					   int c,q = zztext[0]; 

					   zzleng = 1;

					   while((c = input()) && c != q && c != '\n') 
					   {
						   if(c == '\\') {
								zztext[zzleng++] = c;
								zztext[zzleng++] = input();
							} else zztext[zzleng++] =  c;
					   }

					   zztext[zzleng++] = c;
					   zztext[zzleng++] = 0;
					   return _w(STRING);
					 }
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 165 "beaul.l"
return _w(DATE);
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 166 "beaul.l"
return _w(TIME);
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 167 "beaul.l"
return _w(WORD); 
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 168 "beaul.l"
return _w(NUMBER); 
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 169 "beaul.l"
return _w(NUMBER); 
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 171 "beaul.l"
leading(zztext);
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 172 "beaul.l"
space(zztext);
	YY_BREAK
case 53:
/* rule 53 can match eol */
YY_RULE_SETUP
#line 173 "beaul.l"
cr(zztext);
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 174 "beaul.l"
return _w(*zztext); 
	YY_BREAK
case 55:
YY_RULE_SETUP
#line 175 "beaul.l"
ECHO;
	YY_BREAK
#line 1339 "lex.zz.c"
			case YY_STATE_EOF(INITIAL):
			case YY_STATE_EOF(SOURCE):
				zzterminate();

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int zz_amount_of_matched_text = (int) (zz_cp - (zztext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*zz_cp = (zz_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->zz_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed zzin at a new source and called
			 * zzlex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(zz_n_chars) = YY_CURRENT_BUFFER_LVALUE->zz_n_chars;
			YY_CURRENT_BUFFER_LVALUE->zz_input_file = zzin;
			YY_CURRENT_BUFFER_LVALUE->zz_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for zz_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since zz_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (zz_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->zz_ch_buf[(zz_n_chars)] )
			{ /* This was really a NUL. */
			zz_state_type zz_next_state;

			(zz_c_buf_p) = (zztext_ptr) + zz_amount_of_matched_text;

			zz_current_state = zz_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * zz_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			zz_next_state = zz_try_NUL_trans( zz_current_state );

			zz_bp = (zztext_ptr) + YY_MORE_ADJ;

			if ( zz_next_state )
				{
				/* Consume the NUL. */
				zz_cp = ++(zz_c_buf_p);
				zz_current_state = zz_next_state;
				goto zz_match;
				}

			else
				{
				zz_cp = (zz_c_buf_p);
				goto zz_find_action;
				}
			}

		else switch ( zz_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(zz_did_buffer_switch_on_eof) = 0;

				if ( zzwrap( ) )
					{
					/* Note: because we've taken care in
					 * zz_get_next_buffer() to have set up
					 * zztext, we can now set up
					 * zz_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(zz_c_buf_p) = (zztext_ptr) + YY_MORE_ADJ;

					zz_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (zz_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(zz_c_buf_p) =
					(zztext_ptr) + zz_amount_of_matched_text;

				zz_current_state = zz_get_previous_state(  );

				zz_cp = (zz_c_buf_p);
				zz_bp = (zztext_ptr) + YY_MORE_ADJ;
				goto zz_match;

			case EOB_ACT_LAST_MATCH:
				(zz_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->zz_ch_buf[(zz_n_chars)];

				zz_current_state = zz_get_previous_state(  );

				zz_cp = (zz_c_buf_p);
				zz_bp = (zztext_ptr) + YY_MORE_ADJ;
				goto zz_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of zzlex */

/* zz_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int zz_get_next_buffer (void)
{
    	register char *dest = YY_CURRENT_BUFFER_LVALUE->zz_ch_buf;
	register char *source = (zztext_ptr);
	register int number_to_move, i;
	int ret_val;

	if ( (zz_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->zz_ch_buf[(zz_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->zz_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (zz_c_buf_p) - (zztext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((zz_c_buf_p) - (zztext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->zz_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->zz_n_chars = (zz_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->zz_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			YY_FATAL_ERROR(
"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->zz_ch_buf[number_to_move]),
			(zz_n_chars), (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->zz_n_chars = (zz_n_chars);
		}

	if ( (zz_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			zzrestart(zzin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->zz_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((zz_size_t) ((zz_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->zz_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		zz_size_t new_size = (zz_n_chars) + number_to_move + ((zz_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->zz_ch_buf = (char *) zzrealloc((void *) YY_CURRENT_BUFFER_LVALUE->zz_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->zz_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in zz_get_next_buffer()" );
	}

	(zz_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->zz_ch_buf[(zz_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->zz_ch_buf[(zz_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(zztext_ptr) = &YY_CURRENT_BUFFER_LVALUE->zz_ch_buf[0];

	return ret_val;
}

/* zz_get_previous_state - get the state just before the EOB char was reached */

    static zz_state_type zz_get_previous_state (void)
{
	register zz_state_type zz_current_state;
	register char *zz_cp;
    
	zz_current_state = (zz_start);
	zz_current_state += YY_AT_BOL();

	(zz_state_ptr) = (zz_state_buf);
	*(zz_state_ptr)++ = zz_current_state;

	for ( zz_cp = (zztext_ptr) + YY_MORE_ADJ; zz_cp < (zz_c_buf_p); ++zz_cp )
		{
		register YY_CHAR zz_c = (*zz_cp ? zz_ec[YY_SC_TO_UI(*zz_cp)] : 1);
		while ( zz_chk[zz_base[zz_current_state] + zz_c] != zz_current_state )
			{
			zz_current_state = (int) zz_def[zz_current_state];
			if ( zz_current_state >= 199 )
				zz_c = zz_meta[(unsigned int) zz_c];
			}
		zz_current_state = zz_nxt[zz_base[zz_current_state] + (unsigned int) zz_c];
		*(zz_state_ptr)++ = zz_current_state;
		}

	return zz_current_state;
}

/* zz_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = zz_try_NUL_trans( current_state );
 */
    static zz_state_type zz_try_NUL_trans  (zz_state_type zz_current_state )
{
	register int zz_is_jam;
    
	register YY_CHAR zz_c = 1;
	while ( zz_chk[zz_base[zz_current_state] + zz_c] != zz_current_state )
		{
		zz_current_state = (int) zz_def[zz_current_state];
		if ( zz_current_state >= 199 )
			zz_c = zz_meta[(unsigned int) zz_c];
		}
	zz_current_state = zz_nxt[zz_base[zz_current_state] + (unsigned int) zz_c];
	zz_is_jam = (zz_current_state == 198);
	if ( ! zz_is_jam )
		*(zz_state_ptr)++ = zz_current_state;

	return zz_is_jam ? 0 : zz_current_state;
}

    static void zzunput (int c, register char * zz_bp )
{
	register char *zz_cp;
    
    zz_cp = (zz_c_buf_p);

	/* undo effects of setting up zztext */
	*zz_cp = (zz_hold_char);

	if ( zz_cp < YY_CURRENT_BUFFER_LVALUE->zz_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = (zz_n_chars) + 2;
		register char *dest = &YY_CURRENT_BUFFER_LVALUE->zz_ch_buf[
					YY_CURRENT_BUFFER_LVALUE->zz_buf_size + 2];
		register char *source =
				&YY_CURRENT_BUFFER_LVALUE->zz_ch_buf[number_to_move];

		while ( source > YY_CURRENT_BUFFER_LVALUE->zz_ch_buf )
			*--dest = *--source;

		zz_cp += (int) (dest - source);
		zz_bp += (int) (dest - source);
		YY_CURRENT_BUFFER_LVALUE->zz_n_chars =
			(zz_n_chars) = YY_CURRENT_BUFFER_LVALUE->zz_buf_size;

		if ( zz_cp < YY_CURRENT_BUFFER_LVALUE->zz_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--zz_cp = (char) c;

    if ( c == '\n' ){
        --zzlineno;
    }

	(zztext_ptr) = zz_bp;
	(zz_hold_char) = *zz_cp;
	(zz_c_buf_p) = zz_cp;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int zzinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(zz_c_buf_p) = (zz_hold_char);

	if ( *(zz_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* zz_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (zz_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->zz_ch_buf[(zz_n_chars)] )
			/* This was really a NUL. */
			*(zz_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (zz_c_buf_p) - (zztext_ptr);
			++(zz_c_buf_p);

			switch ( zz_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because zz_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					zzrestart(zzin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( zzwrap( ) )
						return EOF;

					if ( ! (zz_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return zzinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(zz_c_buf_p) = (zztext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (zz_c_buf_p);	/* cast for 8-bit char's */
	*(zz_c_buf_p) = '\0';	/* preserve zztext */
	(zz_hold_char) = *++(zz_c_buf_p);

	YY_CURRENT_BUFFER_LVALUE->zz_at_bol = (c == '\n');
	if ( YY_CURRENT_BUFFER_LVALUE->zz_at_bol )
		   
    zzlineno++;
;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void zzrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        zzensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            zz_create_buffer(zzin,YY_BUF_SIZE );
	}

	zz_init_buffer(YY_CURRENT_BUFFER,input_file );
	zz_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void zz_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		zzpop_buffer_state();
	 *		zzpush_buffer_state(new_buffer);
     */
	zzensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(zz_c_buf_p) = (zz_hold_char);
		YY_CURRENT_BUFFER_LVALUE->zz_buf_pos = (zz_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->zz_n_chars = (zz_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	zz_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (zzwrap()) processing, but the only time this flag
	 * is looked at is after zzwrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(zz_did_buffer_switch_on_eof) = 1;
}

static void zz_load_buffer_state  (void)
{
    	(zz_n_chars) = YY_CURRENT_BUFFER_LVALUE->zz_n_chars;
	(zztext_ptr) = (zz_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->zz_buf_pos;
	zzin = YY_CURRENT_BUFFER_LVALUE->zz_input_file;
	(zz_hold_char) = *(zz_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE zz_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) zzalloc(sizeof( struct zz_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in zz_create_buffer()" );

	b->zz_buf_size = size;

	/* zz_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->zz_ch_buf = (char *) zzalloc(b->zz_buf_size + 2  );
	if ( ! b->zz_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in zz_create_buffer()" );

	b->zz_is_our_buffer = 1;

	zz_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with zz_create_buffer()
 * 
 */
    void zz_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->zz_is_our_buffer )
		zzfree((void *) b->zz_ch_buf  );

	zzfree((void *) b  );
}

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a zzrestart() or at EOF.
 */
    static void zz_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	zz_flush_buffer(b );

	b->zz_input_file = file;
	b->zz_fill_buffer = 1;

    /* If b is the current buffer, then zz_init_buffer was _probably_
     * called from zzrestart() or through zz_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->zz_bs_lineno = 1;
        b->zz_bs_column = 0;
    }

        b->zz_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void zz_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->zz_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->zz_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->zz_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->zz_buf_pos = &b->zz_ch_buf[0];

	b->zz_at_bol = 1;
	b->zz_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		zz_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void zzpush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	zzensure_buffer_stack();

	/* This block is copied from zz_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(zz_c_buf_p) = (zz_hold_char);
		YY_CURRENT_BUFFER_LVALUE->zz_buf_pos = (zz_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->zz_n_chars = (zz_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(zz_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from zz_switch_to_buffer. */
	zz_load_buffer_state( );
	(zz_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void zzpop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	zz_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((zz_buffer_stack_top) > 0)
		--(zz_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		zz_load_buffer_state( );
		(zz_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void zzensure_buffer_stack (void)
{
	int num_to_alloc;
    
	if (!(zz_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(zz_buffer_stack) = (struct zz_buffer_state**)zzalloc
								(num_to_alloc * sizeof(struct zz_buffer_state*)
								);
		if ( ! (zz_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in zzensure_buffer_stack()" );
								  
		memset((zz_buffer_stack), 0, num_to_alloc * sizeof(struct zz_buffer_state*));
				
		(zz_buffer_stack_max) = num_to_alloc;
		(zz_buffer_stack_top) = 0;
		return;
	}

	if ((zz_buffer_stack_top) >= ((zz_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (zz_buffer_stack_max) + grow_size;
		(zz_buffer_stack) = (struct zz_buffer_state**)zzrealloc
								((zz_buffer_stack),
								num_to_alloc * sizeof(struct zz_buffer_state*)
								);
		if ( ! (zz_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in zzensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((zz_buffer_stack) + (zz_buffer_stack_max), 0, grow_size * sizeof(struct zz_buffer_state*));
		(zz_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE zz_scan_buffer  (char * base, zz_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) zzalloc(sizeof( struct zz_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in zz_scan_buffer()" );

	b->zz_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->zz_buf_pos = b->zz_ch_buf = base;
	b->zz_is_our_buffer = 0;
	b->zz_input_file = 0;
	b->zz_n_chars = b->zz_buf_size;
	b->zz_is_interactive = 0;
	b->zz_at_bol = 1;
	b->zz_fill_buffer = 0;
	b->zz_buffer_status = YY_BUFFER_NEW;

	zz_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to zzlex() will
 * scan from a @e copy of @a str.
 * @param zzstr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       zz_scan_bytes() instead.
 */
YY_BUFFER_STATE zz_scan_string (zzconst char * zzstr )
{
    
	return zz_scan_bytes(zzstr,strlen(zzstr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to zzlex() will
 * scan from a @e copy of @a bytes.
 * @param bytes the byte buffer to scan
 * @param len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE zz_scan_bytes  (zzconst char * zzbytes, int  _zzbytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	zz_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _zzbytes_len + 2;
	buf = (char *) zzalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in zz_scan_bytes()" );

	for ( i = 0; i < _zzbytes_len; ++i )
		buf[i] = zzbytes[i];

	buf[_zzbytes_len] = buf[_zzbytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = zz_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in zz_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->zz_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void zz_fatal_error (zzconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine zzless() so it works in section 3 code. */

#undef zzless
#define zzless(n) \
	do \
		{ \
		/* Undo effects of setting up zztext. */ \
        int zzless_macro_arg = (n); \
        YY_LESS_LINENO(zzless_macro_arg);\
		zztext[zzleng] = (zz_hold_char); \
		(zz_c_buf_p) = zztext + zzless_macro_arg; \
		(zz_hold_char) = *(zz_c_buf_p); \
		*(zz_c_buf_p) = '\0'; \
		zzleng = zzless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int zzget_lineno  (void)
{
        
    return zzlineno;
}

/** Get the input stream.
 * 
 */
FILE *zzget_in  (void)
{
        return zzin;
}

/** Get the output stream.
 * 
 */
FILE *zzget_out  (void)
{
        return zzout;
}

/** Get the length of the current token.
 * 
 */
int zzget_leng  (void)
{
        return zzleng;
}

/** Get the current token.
 * 
 */

char *zzget_text  (void)
{
        return zztext;
}

/** Set the current line number.
 * @param line_number
 * 
 */
void zzset_lineno (int  line_number )
{
    
    zzlineno = line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * 
 * @see zz_switch_to_buffer
 */
void zzset_in (FILE *  in_str )
{
        zzin = in_str ;
}

void zzset_out (FILE *  out_str )
{
        zzout = out_str ;
}

int zzget_debug  (void)
{
        return zz_flex_debug;
}

void zzset_debug (int  bdebug )
{
        zz_flex_debug = bdebug ;
}

static int zz_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from zzlex_destroy(), so don't allocate here.
     */

    /* We do not touch zzlineno unless the option is enabled. */
    zzlineno =  1;
    
    (zz_buffer_stack) = 0;
    (zz_buffer_stack_top) = 0;
    (zz_buffer_stack_max) = 0;
    (zz_c_buf_p) = (char *) 0;
    (zz_init) = 0;
    (zz_start) = 0;

    (zz_state_buf) = 0;
    (zz_state_ptr) = 0;
    (zz_full_match) = 0;
    (zz_lp) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    zzin = stdin;
    zzout = stdout;
#else
    zzin = (FILE *) 0;
    zzout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * zzlex_init()
     */
    return 0;
}

/* zzlex_destroy is for both reentrant and non-reentrant scanners. */
int zzlex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		zz_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		zzpop_buffer_state();
	}

	/* Destroy the stack itself. */
	zzfree((zz_buffer_stack) );
	(zz_buffer_stack) = NULL;

    zzfree ( (zz_state_buf) );
    (zz_state_buf)  = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * zzlex() is called, initialization will occur. */
    zz_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef zztext_ptr
static void zz_flex_strncpy (char* s1, zzconst char * s2, int n )
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int zz_flex_strlen (zzconst char * s )
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *zzalloc (zz_size_t  size )
{
	return (void *) malloc( size );
}

void *zzrealloc  (void * ptr, zz_size_t  size )
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void zzfree (void * ptr )
{
	free( (char *) ptr );	/* see zzrealloc() for (char *) cast */
}

#define YYTABLES_NAME "zztables"

#line 175 "beaul.l"



int beau_parse()
{
	if(setjmp(env)) return 1;
	return zzparse();
}

