
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with zz or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 10 "macroy.y"

#include <stdio.h>
#include <stdlib.h>
#include "opcodes.h"

extern int   zzlineno;
extern void  update_branch(void *a,void *b);
extern void *new_code(int opcode,char *carg,int iarg,int line);
extern void  new_context(char *name,int handler,int user,int oo);
extern void  start_global(char *name);
extern void  end_global(char *name);
extern void  end_context(char *name);
extern void  argument_count(int);
extern void  argument_type(char*);
extern void  extern_command(char*,char*);
extern char *strdup(const char*);

static void *stack[1024];
static int  top = 0;

static int  tmpdepth = 0;

static void include(char*);
static void begin_function(char *name,int handler,int user,int oo)
{
	/* extern int zzdebug; zzdebug = 1; */
	new_context(name,handler,user,oo);
}

static void return_function(int has_value)
{
	if(!has_value) new_code(OP_PUSH,NULL,PUSH_NIL,zzlineno);
	new_code(OP_RETURN,NULL,0,zzlineno);
}

static void end_function(char *name)
{
	new_code(OP_PUSH,NULL,PUSH_NIL,zzlineno);
	new_code(OP_RETURN,NULL,0,zzlineno);

	end_context(name);
}

static void begin_while()
{
	stack[top++] = new_code(OP_NOP,NULL,0,zzlineno);
}

static void end_while()
{
	void *l1 = stack[--top];
	void *l2 = stack[--top];
	update_branch(new_code(OP_GOTO,NULL,0,zzlineno),l2);
	update_branch(l1,new_code(OP_NOP,NULL,0,zzlineno));
}

static void begin_repeat()
{
	stack[top++] = new_code(OP_NOP,NULL,0,zzlineno);
}

static void end_until()
{
	void *l = stack[--top];
	update_branch(new_code(OP_TEST,NULL,0,zzlineno),l);
}

static void do_while()
{
	stack[top++] = new_code(OP_TEST,NULL,0,zzlineno);
}


static void begin_if()
{
	stack[top++] = new_code(OP_TEST,NULL,0,zzlineno);
}

static void else_if()
{
	void *l = stack[--top];

	stack[top++] = new_code(OP_GOTO,NULL,0,zzlineno);
	update_branch(l,new_code(OP_NOP,NULL,0,zzlineno));
}

static void end_if()
{
	void *l = stack[--top];
	update_branch(l,new_code(OP_NOP,NULL,0,zzlineno));
}

static void push(char *name,int type)
{
	new_code(OP_PUSH,name,type,zzlineno);
}


static void param(char *name,char *type)
{
	new_code(OP_PARAM,name,0,zzlineno);
	argument_type(type);
}

static void pop(char *name,int n)
{
	if(name)
		new_code(OP_STORE,name,n,zzlineno);
	else
		new_code(OP_POP,NULL,n,zzlineno);
}

static void call(char *name,int arity)
{
	new_code(OP_CALL,name,arity,zzlineno);
}

/*===========================================================================*/

static void begin_case(void)
{
	void *l1,*l2,*l3;
	char tmp[20];

	sprintf(tmp,".tmp.%d",tmpdepth++);
	pop(tmp,0);

	l1 = new_code(OP_GOTO,NULL,0,zzlineno);
	l2 = new_code(OP_GOTO,NULL,0,zzlineno); /* endcase case */
	l3 = new_code(OP_NOP, NULL,0,zzlineno);

	update_branch(l1,l3);
	stack[top++] = l2;
}

static void end_case(void)
{
	void *l = stack[--top];
	update_branch(l,new_code(OP_NOP,NULL,0,zzlineno));
	tmpdepth--;
}

static void begin_choice(int count)
{
	char tmp1[20];
	char tmp2[20];

	sprintf(tmp1,".tmp.%d",tmpdepth-1);

	if(count == 1) /* faster */
	{
		push(tmp1,PUSH_IDENT);
		call("=", 2);
	}
	else
	{
		int i;
		for(i=0;i<count;i++)  /* copy all cases */
		{
			sprintf(tmp2,".tmp.%d",tmpdepth+i);
			pop(tmp2,0);
		}

		for(i=0;i<count;i++)  /* = all cases */
		{
			sprintf(tmp2,".tmp.%d",tmpdepth+i);
			push(tmp1,PUSH_IDENT);
			push(tmp2,PUSH_IDENT);
			call("=", 2);
		}

		for(i=0;i<count-1;i++)  /* or all cases */
			call("or",2);
	}

	stack[top++] = new_code(OP_TEST,NULL,0,zzlineno);

}

static void end_choice(void)
{
	void *l1 = stack[--top]; /* OP_TEST */
	void *l2 = stack[top-1]; /* begin_case l2 */

	update_branch(new_code(OP_GOTO,NULL,0,zzlineno),l2);
	update_branch(l1,new_code(OP_NOP ,NULL,0,zzlineno));
}

/*===========================================================================*/

static begin_for(char *name,int by)
{
	char tmp1[20];
	char tmp2[20];

	sprintf(tmp1,".tmp.%d",tmpdepth++);
	sprintf(tmp2,".tmp.%d",tmpdepth++);

	if(by == 0) push("1",PUSH_NUMBER); /* default by */

	pop(tmp2,0);             /* by is on top */

	push(name,PUSH_IDENT); /*  end - start (end is on stack)  */
	call("-",2);

	push(tmp2,PUSH_IDENT); /*  end - start + by */
	call("+",2);

	push(tmp2,PUSH_IDENT); /*  (end - start + 1)/by */
	call("/",2);
	call("int",1);
	pop(tmp1,0);             /* into tmp var */

	begin_while();         /* while tmp > 0 */

	push(tmp1,PUSH_IDENT);
	push("0",PUSH_NUMBER);
	call(">",2);

	do_while();

}

static end_for(char *name)
{
	char tmp1[20];
	char tmp2[20];

	sprintf(tmp2,".tmp.%d",--tmpdepth);
	sprintf(tmp1,".tmp.%d",--tmpdepth);

	push(name,PUSH_IDENT); /* name = name + by */
	push(tmp2,PUSH_IDENT);
	call("+",2);
	pop(name,0);

	push(tmp1,PUSH_IDENT); /* tmp = tmp - 1 */
	push("1",PUSH_NUMBER);
	call("-",2);
	pop(tmp1,0);

	end_while();

/* pmit@up*/
}

/*===========================================================================*/

static begin_loop(char *name)
{
	char tmp1[20];
	char tmp2[20];
	char tmp3[20];

	sprintf(tmp1,".tmp.%d",tmpdepth++);
	sprintf(tmp2,".tmp.%d",tmpdepth++);
	sprintf(tmp3,".tmp.%d",tmpdepth++);

	pop(tmp2,0);             /* get list */
	push(tmp2,PUSH_IDENT);
	call("count",1);       /* count */

	pop(tmp1,0);             /* into tmp var */

	push("1",PUSH_NUMBER);
	pop(tmp3,0);

	begin_while();         /* while tmp > 0 */

	push(tmp1,PUSH_IDENT);
	push("0",PUSH_NUMBER);
	call(">",2);

	do_while();

	push(tmp2,PUSH_IDENT);	
	push(tmp3,PUSH_IDENT);	
	call("[]",2);
	pop(name,0);

}

static end_loop()
{
	char tmp1[20];
	char tmp2[20];
	char tmp3[20];

	sprintf(tmp3,".tmp.%d",--tmpdepth);
	sprintf(tmp2,".tmp.%d",--tmpdepth);
	sprintf(tmp1,".tmp.%d",--tmpdepth);

	push(tmp1,PUSH_IDENT); /* tmp = tmp - 1 */
	push("1",PUSH_NUMBER);
	call("-",2);
	pop(tmp1,0);

	push(tmp3,PUSH_IDENT); /* tmp = tmp + 1 */
	push("1",PUSH_NUMBER);
	call("+",2);
	pop(tmp3,0);

	end_while();

}

/*===========================================================================*/

static void begin_when(void)
{
	void *l1,*l2,*l3;

	l1 = new_code(OP_GOTO,NULL,0,zzlineno);
	l2 = new_code(OP_GOTO,NULL,0,zzlineno); /* endcase when */
	l3 = new_code(OP_NOP, NULL,0,zzlineno);

	update_branch(l1,l3);
	stack[top++] = l2;
}

static void end_when(void)
{
	void *l = stack[--top];
	update_branch(l,new_code(OP_NOP,NULL,0,zzlineno));
}

static void begin_selection(void)
{
	stack[top++] = new_code(OP_TEST,NULL,0,zzlineno);
}

static void end_selection(void)
{
	void *l1 = stack[--top]; /* OP_TEST */
	void *l2 = stack[top-1]; /* begin_when l2 */

	update_branch(new_code(OP_GOTO,NULL,0,zzlineno),l2);
	update_branch(l1,new_code(OP_NOP ,NULL,0,zzlineno));
}

/*===========================================================================*/


/* Line 189 of yacc.c  */
#line 417 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum zztokentype {
     IF = 258,
     AND = 259,
     NOT = 260,
     OR = 261,
     THEN = 262,
     ELSE = 263,
     END = 264,
     RETURN = 265,
     DO = 266,
     FUNCTION = 267,
     ON = 268,
     GLOBAL = 269,
     VECTOR = 270,
     WHILE = 271,
     INCLUDE = 272,
     EXTERN = 273,
     GE = 274,
     LE = 275,
     NE = 276,
     FOR = 277,
     TO = 278,
     BY = 279,
     NIL = 280,
     OBJECT = 281,
     IMPORT = 282,
     EXPORT = 283,
     INLINE = 284,
     CASE = 285,
     OTHERWISE = 286,
     OF = 287,
     IN = 288,
     REPEAT = 289,
     UNTIL = 290,
     LOOP = 291,
     WHEN = 292,
     TELL = 293,
     TASK = 294,
     ARROW = 295,
     WORD = 296,
     STRING = 297,
     NUMBER = 298,
     DATE = 299,
     TIME = 300,
     ENDINLINE = 301
   };
#endif
/* Tokens.  */
#define IF 258
#define AND 259
#define NOT 260
#define OR 261
#define THEN 262
#define ELSE 263
#define END 264
#define RETURN 265
#define DO 266
#define FUNCTION 267
#define ON 268
#define GLOBAL 269
#define VECTOR 270
#define WHILE 271
#define INCLUDE 272
#define EXTERN 273
#define GE 274
#define LE 275
#define NE 276
#define FOR 277
#define TO 278
#define BY 279
#define NIL 280
#define OBJECT 281
#define IMPORT 282
#define EXPORT 283
#define INLINE 284
#define CASE 285
#define OTHERWISE 286
#define OF 287
#define IN 288
#define REPEAT 289
#define UNTIL 290
#define LOOP 291
#define WHEN 292
#define TELL 293
#define TASK 294
#define ARROW 295
#define WORD 296
#define STRING 297
#define NUMBER 298
#define DATE 299
#define TIME 300
#define ENDINLINE 301




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 353 "macroy.y"

	char       *str;
	long		num;



/* Line 214 of yacc.c  */
#line 552 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define zzstype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 564 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 zztype_uint8;
#else
typedef unsigned char zztype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 zztype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char zztype_int8;
#else
typedef short int zztype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 zztype_uint16;
#else
typedef unsigned short int zztype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 zztype_int16;
#else
typedef short int zztype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int zzi)
#else
static int
YYID (zzi)
    int zzi;
#endif
{
  return zzi;
}
#endif

#if ! defined zzoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined zzoverflow || YYERROR_VERBOSE */


#if (! defined zzoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union zzalloc
{
  zztype_int16 zzss_alloc;
  YYSTYPE zzvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union zzalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (zztype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T zzi;				\
	  for (zzi = 0; zzi < (Count); zzi++)	\
	    (To)[zzi] = (From)[zzi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T zznewbytes;						\
	YYCOPY (&zzptr->Stack_alloc, Stack, zzsize);			\
	Stack = &zzptr->Stack_alloc;					\
	zznewbytes = zzstacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	zzptr += zznewbytes / sizeof (*zzptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  128
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   592

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  65
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  86
/* YYNRULES -- Number of rules.  */
#define YYNRULES  192
/* YYNRULES -- Number of states.  */
#define YYNSTATES  336

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   301

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? zztranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const zztype_uint8 zztranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    62,     2,
      49,    50,    59,    61,    52,    57,    55,    60,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    51,    47,
      64,    48,    63,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    53,     2,    54,    58,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    56,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const zztype_uint16 zzprhs[] =
{
       0,     0,     3,     5,     7,     9,    11,    14,    16,    18,
      20,    22,    24,    26,    28,    30,    32,    34,    37,    38,
      44,    47,    50,    53,    57,    62,    65,    68,    71,    74,
      80,    82,    85,    89,    92,    95,    98,   100,   103,   105,
     109,   111,   113,   117,   119,   123,   126,   128,   130,   132,
     134,   136,   138,   140,   143,   147,   154,   155,   162,   163,
     170,   172,   174,   176,   178,   180,   182,   184,   186,   187,
     196,   197,   204,   205,   211,   213,   216,   217,   223,   224,
     233,   235,   238,   239,   245,   247,   252,   253,   259,   260,
     261,   275,   277,   280,   281,   282,   291,   292,   299,   302,
     303,   308,   309,   310,   319,   323,   329,   332,   337,   342,
     344,   346,   351,   355,   359,   366,   373,   376,   378,   380,
     382,   386,   388,   389,   394,   395,   400,   402,   406,   410,
     414,   417,   420,   422,   426,   430,   432,   435,   437,   439,
     442,   444,   446,   448,   452,   454,   456,   458,   460,   463,
     465,   467,   471,   473,   477,   481,   483,   487,   491,   495,
     497,   501,   505,   509,   513,   517,   521,   525,   530,   533,
     535,   539,   541,   545,   547,   549,   551,   553,   555,   557,
     559,   561,   563,   565,   567,   569,   571,   573,   575,   577,
     579,   581,   584
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const zztype_int16 zzrhs[] =
{
      66,     0,    -1,    67,    -1,    68,    -1,   150,    -1,    69,
      -1,    68,    69,    -1,    89,    -1,    79,    -1,    94,    -1,
      71,    -1,    75,    -1,    73,    -1,    74,    -1,    77,    -1,
      47,    -1,    41,    -1,    14,    70,    -1,    -1,    14,    70,
      48,    72,   148,    -1,    27,    70,    -1,    28,    70,    -1,
      76,    80,    -1,    76,    80,    42,    -1,    76,    80,    42,
      78,    -1,    18,    88,    -1,    17,    42,    -1,    17,    70,
      -1,    29,    46,    -1,    81,    80,    82,    67,    87,    -1,
     150,    -1,    49,    50,    -1,    49,    85,    50,    -1,    12,
      88,    -1,    13,    88,    -1,    26,    88,    -1,   150,    -1,
      51,    83,    -1,    84,    -1,    83,    52,    84,    -1,   126,
      -1,    86,    -1,    85,    52,    86,    -1,    70,    -1,    70,
      51,    70,    -1,     9,    88,    -1,    70,    -1,   149,    -1,
      91,    -1,   126,    -1,    90,    -1,    70,    -1,    10,    -1,
      10,   148,    -1,    70,    48,   148,    -1,    70,    53,   129,
      54,    48,   148,    -1,    -1,    70,    55,    70,    48,    92,
     148,    -1,    -1,    70,    55,    43,    48,    93,   148,    -1,
     119,    -1,   116,    -1,   112,    -1,   110,    -1,   104,    -1,
      95,    -1,    99,    -1,    97,    -1,    -1,    36,    70,    33,
     148,    96,    67,     9,    36,    -1,    -1,    38,   148,    98,
      67,     9,    38,    -1,    -1,    37,   100,   101,     9,    37,
      -1,   102,    -1,   101,   102,    -1,    -1,   148,    51,   103,
      67,     9,    -1,    -1,    30,   148,    32,   105,   106,   109,
       9,    30,    -1,   107,    -1,   106,   107,    -1,    -1,   129,
      51,   108,    67,     9,    -1,   150,    -1,    31,    51,    67,
       9,    -1,    -1,    34,   111,    67,    35,   148,    -1,    -1,
      -1,    22,    70,    48,   148,   113,    23,   148,   115,    11,
     114,    67,     9,    22,    -1,   150,    -1,    24,   148,    -1,
      -1,    -1,    16,   117,   148,    11,   118,    67,     9,    16,
      -1,    -1,     3,   148,     7,   120,    67,   121,    -1,     9,
       3,    -1,    -1,     8,   122,    67,   121,    -1,    -1,    -1,
       8,     3,   123,   148,     7,   124,    67,   121,    -1,    49,
     134,    50,    -1,    49,   130,    52,   129,    50,    -1,    49,
      50,    -1,    70,    49,   128,    50,    -1,    70,    49,   134,
      50,    -1,   125,    -1,   127,    -1,   140,    53,   129,    54,
      -1,   140,    55,    70,    -1,   140,    55,    43,    -1,    70,
      40,    70,    49,   128,    50,    -1,    70,    40,    70,    49,
     134,    50,    -1,    70,    78,    -1,   150,    -1,   129,    -1,
     130,    -1,   130,    52,   129,    -1,   148,    -1,    -1,    70,
     132,    51,   148,    -1,    -1,    42,   133,    51,   148,    -1,
     131,    -1,   131,    52,   130,    -1,   131,    52,   134,    -1,
     130,    52,   134,    -1,   137,   137,    -1,   135,   137,    -1,
     135,    -1,    56,   129,    56,    -1,    53,   128,    54,    -1,
      43,    -1,    57,    43,    -1,    70,    -1,    42,    -1,    44,
      45,    -1,    44,    -1,    45,    -1,   126,    -1,    49,   148,
      50,    -1,   138,    -1,   137,    -1,   136,    -1,    25,    -1,
      57,   140,    -1,   140,    -1,   139,    -1,   141,    58,   142,
      -1,   141,    -1,   143,    59,   142,    -1,   143,    60,   142,
      -1,   142,    -1,   144,    61,   143,    -1,   144,    57,   143,
      -1,   144,    62,   143,    -1,   143,    -1,   145,    63,   144,
      -1,   145,    48,   144,    -1,   145,    64,   144,    -1,   145,
      19,   144,    -1,   145,    20,   144,    -1,   145,    21,   144,
      -1,   145,    33,   144,    -1,   145,     5,    33,   144,    -1,
       5,   145,    -1,   144,    -1,   146,     4,   145,    -1,   145,
      -1,   147,     6,   146,    -1,   146,    -1,   147,    -1,    63,
      -1,    48,    -1,    64,    -1,    19,    -1,    20,    -1,    21,
      -1,    33,    -1,     5,    -1,    58,    -1,    59,    -1,    60,
      -1,    61,    -1,    57,    -1,    62,    -1,     4,    -1,     6,
      -1,    53,    54,    -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const zztype_uint16 zzrline[] =
{
       0,   426,   426,   429,   430,   433,   434,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   448,   450,   452,   452,
     456,   460,   464,   465,   468,   472,   475,   476,   479,   484,
     487,   488,   489,   492,   493,   494,   497,   498,   504,   505,
     508,   511,   512,   515,   516,   519,   521,   522,   528,   529,
     530,   531,   534,   535,   539,   540,   545,   545,   551,   551,
     561,   562,   563,   564,   565,   566,   567,   568,   573,   573,
     580,   580,   587,   587,   591,   592,   595,   595,   600,   600,
     606,   607,   610,   610,   614,   615,   621,   621,   628,   629,
     628,   634,   635,   640,   641,   640,   648,   648,   653,   654,
     654,   655,   656,   655,   663,   664,   665,   669,   670,   671,
     672,   673,   674,   678,   682,   689,   700,   710,   711,   714,
     715,   718,   721,   721,   722,   722,   725,   726,   727,   728,
     731,   732,   735,   738,   740,   743,   744,   747,   748,   749,
     751,   752,   753,   754,   755,   756,   757,   758,   759,   762,
     763,   768,   769,   772,   773,   774,   777,   778,   779,   780,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     795,   796,   799,   800,   803,   806,   807,   808,   809,   810,
     811,   812,   813,   814,   815,   816,   817,   818,   819,   820,
     821,   822,   825
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const zztname[] =
{
  "$end", "error", "$undefined", "IF", "AND", "NOT", "OR", "THEN", "ELSE",
  "END", "RETURN", "DO", "FUNCTION", "ON", "GLOBAL", "VECTOR", "WHILE",
  "INCLUDE", "EXTERN", "GE", "LE", "NE", "FOR", "TO", "BY", "NIL",
  "OBJECT", "IMPORT", "EXPORT", "INLINE", "CASE", "OTHERWISE", "OF", "IN",
  "REPEAT", "UNTIL", "LOOP", "WHEN", "TELL", "TASK", "ARROW", "WORD",
  "STRING", "NUMBER", "DATE", "TIME", "ENDINLINE", "';'", "'='", "'('",
  "')'", "':'", "','", "'['", "']'", "'.'", "'|'", "'-'", "'^'", "'*'",
  "'/'", "'+'", "'&'", "'>'", "'<'", "$accept", "script", "block", "lines",
  "line", "name", "declare", "$@1", "import", "export", "extern",
  "extern_name", "include", "inline", "function", "param_declare",
  "functionheader", "super_declare", "super_list", "super", "param_list",
  "param", "endfunction", "fname", "statement", "return", "assignement",
  "$@2", "$@3", "control", "loop", "$@4", "tell", "$@5", "when", "$@6",
  "selections", "selection", "$@7", "case", "$@8", "choices", "choice",
  "$@9", "otherwise", "repeat", "$@10", "for", "$@11", "$@12", "by",
  "while", "$@13", "$@14", "if", "$@15", "closeif", "$@16", "$@17", "$@18",
  "definition", "function_call", "inline_object", "param_or_empty",
  "parameters", "parameter", "attribute", "$@19", "$@20", "attribute_list",
  "vector_list", "matrix", "vector", "list", "number", "atom",
  "atom_or_number", "power", "factor", "term", "condition", "conjonction",
  "disjonction", "expression", "operator", "empty", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const zztype_uint16 zztoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    59,    61,    40,
      41,    58,    44,    91,    93,    46,   124,    45,    94,    42,
      47,    43,    38,    62,    60
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const zztype_uint8 zzr1[] =
{
       0,    65,    66,    67,    67,    68,    68,    69,    69,    69,
      69,    69,    69,    69,    69,    69,    70,    71,    72,    71,
      73,    74,    75,    75,    75,    76,    77,    77,    78,    79,
      80,    80,    80,    81,    81,    81,    82,    82,    83,    83,
      84,    85,    85,    86,    86,    87,    88,    88,    89,    89,
      89,    89,    90,    90,    91,    91,    92,    91,    93,    91,
      94,    94,    94,    94,    94,    94,    94,    94,    96,    95,
      98,    97,   100,    99,   101,   101,   103,   102,   105,   104,
     106,   106,   108,   107,   109,   109,   111,   110,   113,   114,
     112,   115,   115,   117,   118,   116,   120,   119,   121,   122,
     121,   123,   124,   121,   125,   125,   125,   126,   126,   126,
     126,   126,   126,   126,   126,   126,   127,   128,   128,   129,
     129,   130,   132,   131,   133,   131,   134,   134,   134,   134,
     135,   135,   136,   137,   138,   139,   139,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   141,
     141,   142,   142,   143,   143,   143,   144,   144,   144,   144,
     145,   145,   145,   145,   145,   145,   145,   145,   145,   145,
     146,   146,   147,   147,   148,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   150
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const zztype_uint8 zzr2[] =
{
       0,     2,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     0,     5,
       2,     2,     2,     3,     4,     2,     2,     2,     2,     5,
       1,     2,     3,     2,     2,     2,     1,     2,     1,     3,
       1,     1,     3,     1,     3,     2,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     6,     0,     6,     0,     6,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     8,
       0,     6,     0,     5,     1,     2,     0,     5,     0,     8,
       1,     2,     0,     5,     1,     4,     0,     5,     0,     0,
      13,     1,     2,     0,     0,     8,     0,     6,     2,     0,
       4,     0,     0,     8,     3,     5,     2,     4,     4,     1,
       1,     4,     3,     3,     6,     6,     2,     1,     1,     1,
       3,     1,     0,     4,     0,     4,     1,     3,     3,     3,
       2,     2,     1,     3,     3,     1,     2,     1,     1,     2,
       1,     1,     1,     3,     1,     1,     1,     1,     2,     1,
       1,     3,     1,     3,     3,     1,     3,     3,     3,     1,
       3,     3,     3,     3,     3,     3,     3,     4,     2,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     0
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const zztype_uint8 zzdefact[] =
{
     192,     0,    52,     0,     0,     0,    93,     0,     0,     0,
     147,     0,     0,     0,     0,    86,     0,    72,     0,    16,
     138,   140,   141,    15,     0,   192,     0,     0,     0,     2,
       3,     5,    51,    10,    12,    13,    11,   192,    14,     8,
     192,     7,    50,    48,     9,    65,    67,    66,    64,    63,
      62,    61,    60,   109,    49,   110,   132,   146,   145,   144,
       0,     4,     0,   135,     0,   137,   142,   150,   149,   152,
     155,   159,   169,   171,   173,   174,     0,    53,   189,   182,
     190,   178,   179,   180,   181,   176,     0,   187,   183,   184,
     185,   186,   188,   175,   177,    46,    33,    47,    34,    17,
       0,    26,    27,    25,     0,    35,    20,    21,     0,   192,
       0,     0,    70,   139,   138,   106,   137,     0,   126,     0,
     121,     0,   118,   119,   121,   117,     0,   148,     1,     6,
       0,     0,     0,   192,     0,     0,   116,     0,    22,    30,
     192,   131,   130,     0,     0,   168,   136,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    96,   191,    18,     0,     0,    78,     0,
       0,     0,    74,     0,   192,     0,     0,     0,     0,   104,
     143,   134,     0,   133,    28,     0,    54,     0,   119,     0,
       0,     0,     0,    31,    43,     0,    41,    23,     0,   192,
      36,     0,   113,   112,   151,   153,   154,   157,   156,   158,
       0,   163,   164,   165,   166,   161,   160,   162,   170,   172,
     192,     0,    94,    88,     0,     0,    68,     0,    75,    76,
       0,     0,     0,     0,   129,   127,   128,   120,   192,   107,
       0,   108,     0,    58,    56,     0,    32,     0,    24,    37,
      38,    40,     0,   111,   167,     0,    19,   192,     0,   192,
      80,     0,    87,   192,    73,   192,     0,   125,   123,   105,
       0,     0,     0,     0,     0,     0,    44,    42,     0,     0,
      29,    99,     0,    97,     0,     0,     0,    81,     0,    84,
      82,     0,     0,    71,     0,   114,   115,    55,    59,    57,
      39,    45,   101,   192,    98,     0,   192,   192,     0,   192,
       0,    77,     0,     0,    95,     0,     0,    91,     0,    79,
       0,    69,     0,   100,    92,    89,    85,    83,   102,   192,
     192,     0,     0,     0,   103,    90
};

/* YYDEFGOTO[NTERM-NUM].  */
static const zztype_int16 zzdefgoto[] =
{
      -1,    28,    29,    30,    31,    65,    33,   221,    34,    35,
      36,    37,    38,   136,    39,   138,    40,   199,   249,   250,
     195,   196,   280,    96,    41,    42,    43,   275,   274,    44,
      45,   263,    46,   174,    47,   111,   171,   172,   265,    48,
     224,   259,   260,   309,   288,    49,   109,    50,   258,   329,
     316,    51,   100,   257,    52,   220,   283,   303,   312,   330,
      53,    66,    55,   121,   122,   123,   118,   176,   175,   234,
      56,    57,    58,    59,    67,    68,    69,    70,    71,    72,
      73,    74,    75,   124,    97,    61
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -279
static const zztype_int16 zzpact[] =
{
     417,   466,   466,   355,   355,   -15,  -279,    16,   355,   -15,
    -279,   355,   -15,   -15,   466,  -279,   -15,  -279,   466,  -279,
    -279,    -7,  -279,  -279,    34,   466,   466,   535,    68,  -279,
     417,  -279,    59,  -279,  -279,  -279,  -279,    23,  -279,  -279,
      23,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,    27,  -279,    33,  -279,    33,  -279,
     -19,  -279,   466,  -279,   508,    24,  -279,  -279,   -19,    37,
    -279,   -37,    -1,    22,    96,    95,    97,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,    61,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,    72,
     466,  -279,  -279,  -279,    73,  -279,  -279,  -279,    84,   417,
      93,   466,  -279,  -279,    74,  -279,    94,    77,    78,    82,
      86,    85,  -279,    88,  -279,  -279,    90,   -19,  -279,  -279,
     101,   -15,   466,   487,   466,    28,  -279,   -21,    99,  -279,
      91,  -279,  -279,   466,    51,    22,  -279,   529,   529,   529,
     529,   529,   529,   115,   529,   529,   529,   529,   529,   529,
     529,   466,   466,  -279,  -279,  -279,   138,   466,  -279,   116,
     466,   113,  -279,   102,   417,   108,   109,   487,   487,  -279,
    -279,  -279,   466,  -279,  -279,   114,  -279,   100,   112,   117,
     111,   120,   127,  -279,   125,    46,  -279,   151,   535,   417,
    -279,   128,  -279,  -279,  -279,  -279,  -279,   -37,   -37,   -37,
     529,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    96,
     417,   466,  -279,  -279,   466,   466,  -279,   144,  -279,  -279,
     174,   466,   466,   135,  -279,   134,  -279,  -279,   487,  -279,
     487,  -279,   139,  -279,  -279,   -15,  -279,   -15,  -279,   136,
    -279,    27,   182,  -279,    -1,    54,  -279,   417,   169,   444,
    -279,   142,  -279,   417,  -279,   417,   156,  -279,  -279,  -279,
     487,   146,   147,   466,   466,   466,  -279,  -279,   535,   355,
    -279,   195,   199,  -279,   194,   466,   153,  -279,   196,  -279,
    -279,   197,   198,  -279,   134,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,   417,  -279,   200,   186,   417,   187,   417,
     176,  -279,   466,    54,  -279,   466,   207,  -279,   210,  -279,
     212,  -279,   215,  -279,  -279,  -279,  -279,  -279,  -279,   417,
     417,   214,    54,   202,  -279,  -279
};

/* YYPGOTO[NTERM-NUM].  */
static const zztype_int16 zzpgoto[] =
{
    -279,  -279,    92,  -279,   201,     0,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,    29,  -279,   185,  -279,  -279,  -279,   -51,
    -279,   -18,  -279,    17,  -279,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,  -279,    57,  -279,  -279,
    -279,  -279,   -22,  -279,  -279,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,  -278,  -279,  -279,  -279,
    -279,    15,  -279,  -132,    18,    -6,  -279,  -279,  -279,    -5,
    -279,  -279,    55,  -279,  -279,    10,  -279,  -116,   -85,  -108,
     -56,    81,  -279,    79,  -279,   -23
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -143
static const zztype_int16 zztable[] =
{
      32,   187,   125,    95,    95,    99,   145,   102,    95,   104,
      60,    95,   106,   107,   139,    54,   110,   139,   117,   119,
      19,    98,   148,   149,   116,   103,    19,   153,   105,   193,
      32,   204,   205,   206,   143,   323,   144,   127,   113,    62,
      60,   154,   155,   156,   126,    54,   211,   212,   213,   214,
     215,   216,   217,   130,   334,   157,   150,    19,   101,    10,
     151,   152,   281,   282,   131,   207,   208,   209,   128,    19,
     158,   191,   137,   133,   127,    19,   114,    63,    21,    22,
      76,    77,  -142,    24,   115,   159,   160,    25,   130,    26,
      26,    64,    19,   108,   202,   147,   246,   112,   247,   131,
     161,   162,   254,   120,   163,   218,   271,   132,   133,    32,
     125,   141,   134,   142,   135,   164,   168,   200,    62,    60,
     165,   167,   227,   130,    54,  -124,   170,   188,   189,   177,
     178,   185,   179,   116,   131,   192,   180,   194,    10,   181,
     182,   197,   198,   133,   203,  -122,   183,   184,   210,   222,
     239,   225,   190,   229,    19,    20,    63,    21,    22,   231,
     232,   201,    24,   238,   240,   242,    25,   241,   243,    26,
      64,   188,   235,   236,    32,   244,   245,   116,   116,   166,
     130,   264,   253,   266,    60,   269,   270,   273,   278,    54,
     173,   279,   285,   290,   293,   233,   295,   296,   302,    32,
     237,   169,   304,   305,   307,   308,   310,   311,    60,    60,
     315,   186,   321,   251,    54,   125,   314,   319,   325,   326,
      32,   327,   328,   333,   335,   140,   248,   300,   228,   277,
      60,   129,   188,   272,   188,    54,   289,   287,   116,     0,
     116,     0,   261,   219,     0,   276,   223,   194,     0,   226,
     173,     0,     0,     0,     0,     0,     0,    32,   237,     0,
       0,     0,     0,    32,   294,    32,   230,    60,     0,     0,
     116,     0,    54,    60,     0,    60,     0,   261,    54,    95,
      54,     0,     0,   317,     0,     0,     0,     0,    60,     0,
       0,   252,     0,   251,     0,     0,   301,     0,     0,     0,
     256,     0,     0,    32,   262,     0,     0,    32,     0,    32,
     267,   268,   255,    60,     0,     0,     0,    60,    54,    60,
       0,     0,    54,     0,    54,     0,     0,     0,     0,    32,
      32,     0,     0,     0,     0,     0,     0,     0,     0,    60,
      60,     0,     0,     0,    54,    54,     0,     0,     0,   284,
       0,     0,   297,   298,   299,   291,     0,   292,     0,    78,
      79,    80,     0,     0,   306,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    81,    82,    83,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    84,     0,
       0,   322,     0,     0,   324,   313,    19,     0,     0,   318,
       0,   320,     0,    85,     0,     0,     0,     0,    86,     0,
       0,     0,    87,    88,    89,    90,    91,    92,    93,    94,
       1,   331,   332,     0,     0,     0,     0,     2,     0,     3,
       4,     5,     0,     6,     7,     8,     0,     0,     0,     9,
       0,     0,    10,    11,    12,    13,     0,    14,     0,    62,
       0,    15,     0,    16,    17,    18,     0,     0,    19,    20,
       0,    21,    22,     0,    23,     0,    24,     0,     0,    10,
      25,    62,     0,    26,    27,   286,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    19,    20,    63,    21,    22,
       0,    10,    62,    24,     0,     0,     0,    25,     0,     0,
      26,    64,     0,     0,     0,     0,     0,    19,    20,    63,
      21,    22,    10,     0,     0,    24,     0,     0,     0,    25,
       0,     0,    26,    64,     0,     0,     0,     0,    19,   114,
      63,    21,    22,    10,     0,     0,    24,     0,     0,     0,
      25,     0,     0,    26,    64,     0,     0,     0,     0,    19,
      20,   146,    21,    22,    10,     0,     0,    24,     0,     0,
      10,    25,     0,     0,    26,    27,     0,     0,     0,     0,
      19,    20,    63,    21,    22,     0,    19,    20,    24,    21,
      22,     0,    25,     0,    24,    26,    64,     0,    25,     0,
       0,    26,    27
};

static const zztype_int16 zzcheck[] =
{
       0,   133,    25,     3,     4,     5,    62,     7,     8,     9,
       0,    11,    12,    13,    37,     0,    16,    40,    24,    24,
      41,     4,    59,    60,    24,     8,    41,     5,    11,    50,
      30,   147,   148,   149,    53,   313,    55,    27,    45,     5,
      30,    19,    20,    21,    26,    30,   154,   155,   156,   157,
     158,   159,   160,    29,   332,    33,    57,    41,    42,    25,
      61,    62,     8,     9,    40,   150,   151,   152,     0,    41,
      48,    43,    49,    49,    64,    41,    42,    43,    44,    45,
       1,     2,    55,    49,    50,    63,    64,    53,    29,    56,
      56,    57,    41,    14,    43,    58,    50,    18,    52,    40,
       4,     6,   210,    24,     7,   161,   238,    48,    49,   109,
     133,    56,    53,    58,    55,    54,    32,   140,     5,   109,
      48,    48,     9,    29,   109,    51,    33,   133,   133,    52,
      52,   131,    50,   133,    40,   135,    50,   137,    25,    54,
      52,    42,    51,    49,   144,    51,    56,    46,    33,    11,
      50,    35,   134,    51,    41,    42,    43,    44,    45,    51,
      51,   143,    49,    49,    52,    54,    53,    50,    48,    56,
      57,   177,   178,   178,   174,    48,    51,   177,   178,   100,
      29,    37,    54,     9,   174,    50,    52,    48,    52,   174,
     111,     9,    23,    51,    38,   177,    50,    50,     3,   199,
     182,   109,     3,     9,    51,     9,     9,     9,   198,   199,
      24,   132,    36,   198,   199,   238,    16,    30,    11,     9,
     220,     9,     7,     9,    22,    40,   197,   278,   171,   247,
     220,    30,   238,   238,   240,   220,   259,   259,   238,    -1,
     240,    -1,   224,   162,    -1,   245,   167,   247,    -1,   170,
     171,    -1,    -1,    -1,    -1,    -1,    -1,   257,   240,    -1,
      -1,    -1,    -1,   263,   270,   265,   174,   257,    -1,    -1,
     270,    -1,   257,   263,    -1,   265,    -1,   259,   263,   279,
     265,    -1,    -1,   306,    -1,    -1,    -1,    -1,   278,    -1,
      -1,   199,    -1,   278,    -1,    -1,   279,    -1,    -1,    -1,
     221,    -1,    -1,   303,   225,    -1,    -1,   307,    -1,   309,
     231,   232,   220,   303,    -1,    -1,    -1,   307,   303,   309,
      -1,    -1,   307,    -1,   309,    -1,    -1,    -1,    -1,   329,
     330,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   329,
     330,    -1,    -1,    -1,   329,   330,    -1,    -1,    -1,   257,
      -1,    -1,   273,   274,   275,   263,    -1,   265,    -1,     4,
       5,     6,    -1,    -1,   285,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,
      -1,   312,    -1,    -1,   315,   303,    41,    -1,    -1,   307,
      -1,   309,    -1,    48,    -1,    -1,    -1,    -1,    53,    -1,
      -1,    -1,    57,    58,    59,    60,    61,    62,    63,    64,
       3,   329,   330,    -1,    -1,    -1,    -1,    10,    -1,    12,
      13,    14,    -1,    16,    17,    18,    -1,    -1,    -1,    22,
      -1,    -1,    25,    26,    27,    28,    -1,    30,    -1,     5,
      -1,    34,    -1,    36,    37,    38,    -1,    -1,    41,    42,
      -1,    44,    45,    -1,    47,    -1,    49,    -1,    -1,    25,
      53,     5,    -1,    56,    57,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    41,    42,    43,    44,    45,
      -1,    25,     5,    49,    -1,    -1,    -1,    53,    -1,    -1,
      56,    57,    -1,    -1,    -1,    -1,    -1,    41,    42,    43,
      44,    45,    25,    -1,    -1,    49,    -1,    -1,    -1,    53,
      -1,    -1,    56,    57,    -1,    -1,    -1,    -1,    41,    42,
      43,    44,    45,    25,    -1,    -1,    49,    -1,    -1,    -1,
      53,    -1,    -1,    56,    57,    -1,    -1,    -1,    -1,    41,
      42,    43,    44,    45,    25,    -1,    -1,    49,    -1,    -1,
      25,    53,    -1,    -1,    56,    57,    -1,    -1,    -1,    -1,
      41,    42,    43,    44,    45,    -1,    41,    42,    49,    44,
      45,    -1,    53,    -1,    49,    56,    57,    -1,    53,    -1,
      -1,    56,    57
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const zztype_uint8 zzstos[] =
{
       0,     3,    10,    12,    13,    14,    16,    17,    18,    22,
      25,    26,    27,    28,    30,    34,    36,    37,    38,    41,
      42,    44,    45,    47,    49,    53,    56,    57,    66,    67,
      68,    69,    70,    71,    73,    74,    75,    76,    77,    79,
      81,    89,    90,    91,    94,    95,    97,    99,   104,   110,
     112,   116,   119,   125,   126,   127,   135,   136,   137,   138,
     140,   150,     5,    43,    57,    70,   126,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   148,     4,     5,
       6,    19,    20,    21,    33,    48,    53,    57,    58,    59,
      60,    61,    62,    63,    64,    70,    88,   149,    88,    70,
     117,    42,    70,    88,    70,    88,    70,    70,   148,   111,
      70,   100,   148,    45,    42,    50,    70,   130,   131,   134,
     148,   128,   129,   130,   148,   150,   129,   140,     0,    69,
      29,    40,    48,    49,    53,    55,    78,    49,    80,   150,
      80,   137,   137,    53,    55,   145,    43,    58,    59,    60,
      57,    61,    62,     5,    19,    20,    21,    33,    48,    63,
      64,     4,     6,     7,    54,    48,   148,    48,    32,    67,
      33,   101,   102,   148,    98,   133,   132,    52,    52,    50,
      50,    54,    52,    56,    46,    70,   148,   128,   130,   134,
     129,    43,    70,    50,    70,    85,    86,    42,    51,    82,
     150,   129,    43,    70,   142,   142,   142,   143,   143,   143,
      33,   144,   144,   144,   144,   144,   144,   144,   145,   146,
     120,    72,    11,   148,   105,    35,   148,     9,   102,    51,
      67,    51,    51,   129,   134,   130,   134,   129,    49,    50,
      52,    50,    54,    48,    48,    51,    50,    52,    78,    83,
      84,   126,    67,    54,   144,    67,   148,   118,   113,   106,
     107,   129,   148,    96,    37,   103,     9,   148,   148,    50,
      52,   128,   134,    48,    93,    92,    70,    86,    52,     9,
      87,     8,     9,   121,    67,    23,    31,   107,   109,   150,
      51,    67,    67,    38,   130,    50,    50,   148,   148,   148,
      84,    88,     3,   122,     3,     9,   148,    51,     9,   108,
       9,     9,   123,    67,    16,    24,   115,   150,    67,    30,
      67,    36,   148,   121,   148,    11,     9,     9,     7,   114,
     124,    67,    67,     9,   121,    22
};

#define zzerrok		(zzerrstatus = 0)
#define zzclearin	(zzchar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto zzacceptlab
#define YYABORT		goto zzabortlab
#define YYERROR		goto zzerrorlab


/* Like YYERROR except do call zzerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto zzerrlab

#define YYRECOVERING()  (!!zzerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (zzchar == YYEMPTY && zzlen == 1)				\
    {								\
      zzchar = (Token);						\
      zzlval = (Value);						\
      zztoken = YYTRANSLATE (zzchar);				\
      YYPOPSTACK (1);						\
      goto zzbackup;						\
    }								\
  else								\
    {								\
      zzerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `zzlex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX zzlex (YYLEX_PARAM)
#else
# define YYLEX zzlex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (zzdebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (zzdebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      zz_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
zz_symbol_value_print (FILE *zzoutput, int zztype, YYSTYPE const * const zzvaluep)
#else
static void
zz_symbol_value_print (zzoutput, zztype, zzvaluep)
    FILE *zzoutput;
    int zztype;
    YYSTYPE const * const zzvaluep;
#endif
{
  if (!zzvaluep)
    return;
# ifdef YYPRINT
  if (zztype < YYNTOKENS)
    YYPRINT (zzoutput, zztoknum[zztype], *zzvaluep);
# else
  YYUSE (zzoutput);
# endif
  switch (zztype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
zz_symbol_print (FILE *zzoutput, int zztype, YYSTYPE const * const zzvaluep)
#else
static void
zz_symbol_print (zzoutput, zztype, zzvaluep)
    FILE *zzoutput;
    int zztype;
    YYSTYPE const * const zzvaluep;
#endif
{
  if (zztype < YYNTOKENS)
    YYFPRINTF (zzoutput, "token %s (", zztname[zztype]);
  else
    YYFPRINTF (zzoutput, "nterm %s (", zztname[zztype]);

  zz_symbol_value_print (zzoutput, zztype, zzvaluep);
  YYFPRINTF (zzoutput, ")");
}

/*------------------------------------------------------------------.
| zz_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
zz_stack_print (zztype_int16 *zzbottom, zztype_int16 *zztop)
#else
static void
zz_stack_print (zzbottom, zztop)
    zztype_int16 *zzbottom;
    zztype_int16 *zztop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; zzbottom <= zztop; zzbottom++)
    {
      int zzbot = *zzbottom;
      YYFPRINTF (stderr, " %d", zzbot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (zzdebug)							\
    zz_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
zz_reduce_print (YYSTYPE *zzvsp, int zzrule)
#else
static void
zz_reduce_print (zzvsp, zzrule)
    YYSTYPE *zzvsp;
    int zzrule;
#endif
{
  int zznrhs = zzr2[zzrule];
  int zzi;
  unsigned long int zzlno = zzrline[zzrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     zzrule - 1, zzlno);
  /* The symbols being reduced.  */
  for (zzi = 0; zzi < zznrhs; zzi++)
    {
      YYFPRINTF (stderr, "   $%d = ", zzi + 1);
      zz_symbol_print (stderr, zzrhs[zzprhs[zzrule] + zzi],
		       &(zzvsp[(zzi + 1) - (zznrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (zzdebug)				\
    zz_reduce_print (zzvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int zzdebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef zzstrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define zzstrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
zzstrlen (const char *zzstr)
#else
static YYSIZE_T
zzstrlen (zzstr)
    const char *zzstr;
#endif
{
  YYSIZE_T zzlen;
  for (zzlen = 0; zzstr[zzlen]; zzlen++)
    continue;
  return zzlen;
}
#  endif
# endif

# ifndef zzstpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define zzstpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
zzstpcpy (char *zzdest, const char *zzsrc)
#else
static char *
zzstpcpy (zzdest, zzsrc)
    char *zzdest;
    const char *zzsrc;
#endif
{
  char *zzd = zzdest;
  const char *zzs = zzsrc;

  while ((*zzd++ = *zzs++) != '\0')
    continue;

  return zzd - 1;
}
#  endif
# endif

# ifndef zztnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for zzerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from zztname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
zztnamerr (char *zzres, const char *zzstr)
{
  if (*zzstr == '"')
    {
      YYSIZE_T zzn = 0;
      char const *zzp = zzstr;

      for (;;)
	switch (*++zzp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++zzp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (zzres)
	      zzres[zzn] = *zzp;
	    zzn++;
	    break;

	  case '"':
	    if (zzres)
	      zzres[zzn] = '\0';
	    return zzn;
	  }
    do_not_strip_quotes: ;
    }

  if (! zzres)
    return zzstrlen (zzstr);

  return zzstpcpy (zzres, zzstr) - zzres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
zzsyntax_error (char *zzresult, int zzstate, int zzchar)
{
  int zzn = zzpact[zzstate];

  if (! (YYPACT_NINF < zzn && zzn <= YYLAST))
    return 0;
  else
    {
      int zztype = YYTRANSLATE (zzchar);
      YYSIZE_T zzsize0 = zztnamerr (0, zztname[zztype]);
      YYSIZE_T zzsize = zzsize0;
      YYSIZE_T zzsize1;
      int zzsize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *zzarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int zzx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *zzfmt;
      char const *zzf;
      static char const zzunexpected[] = "syntax error, unexpected %s";
      static char const zzexpecting[] = ", expecting %s";
      static char const zzor[] = " or %s";
      char zzformat[sizeof zzunexpected
		    + sizeof zzexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof zzor - 1))];
      char const *zzprefix = zzexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int zzxbegin = zzn < 0 ? -zzn : 0;

      /* Stay within bounds of both zzcheck and zztname.  */
      int zzchecklim = YYLAST - zzn + 1;
      int zzxend = zzchecklim < YYNTOKENS ? zzchecklim : YYNTOKENS;
      int zzcount = 1;

      zzarg[0] = zztname[zztype];
      zzfmt = zzstpcpy (zzformat, zzunexpected);

      for (zzx = zzxbegin; zzx < zzxend; ++zzx)
	if (zzcheck[zzx + zzn] == zzx && zzx != YYTERROR)
	  {
	    if (zzcount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		zzcount = 1;
		zzsize = zzsize0;
		zzformat[sizeof zzunexpected - 1] = '\0';
		break;
	      }
	    zzarg[zzcount++] = zztname[zzx];
	    zzsize1 = zzsize + zztnamerr (0, zztname[zzx]);
	    zzsize_overflow |= (zzsize1 < zzsize);
	    zzsize = zzsize1;
	    zzfmt = zzstpcpy (zzfmt, zzprefix);
	    zzprefix = zzor;
	  }

      zzf = YY_(zzformat);
      zzsize1 = zzsize + zzstrlen (zzf);
      zzsize_overflow |= (zzsize1 < zzsize);
      zzsize = zzsize1;

      if (zzsize_overflow)
	return YYSIZE_MAXIMUM;

      if (zzresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *zzp = zzresult;
	  int zzi = 0;
	  while ((*zzp = *zzf) != '\0')
	    {
	      if (*zzp == '%' && zzf[1] == 's' && zzi < zzcount)
		{
		  zzp += zztnamerr (zzp, zzarg[zzi++]);
		  zzf += 2;
		}
	      else
		{
		  zzp++;
		  zzf++;
		}
	    }
	}
      return zzsize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
zzdestruct (const char *zzmsg, int zztype, YYSTYPE *zzvaluep)
#else
static void
zzdestruct (zzmsg, zztype, zzvaluep)
    const char *zzmsg;
    int zztype;
    YYSTYPE *zzvaluep;
#endif
{
  YYUSE (zzvaluep);

  if (!zzmsg)
    zzmsg = "Deleting";
  YY_SYMBOL_PRINT (zzmsg, zztype, zzvaluep, zzlocationp);

  switch (zztype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int zzparse (void *YYPARSE_PARAM);
#else
int zzparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int zzparse (void);
#else
int zzparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int zzchar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE zzlval;

/* Number of syntax errors so far.  */
int zznerrs;



/*-------------------------.
| zzparse or zzpush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
zzparse (void *YYPARSE_PARAM)
#else
int
zzparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
zzparse (void)
#else
int
zzparse ()

#endif
#endif
{


    int zzstate;
    /* Number of tokens to shift before error messages enabled.  */
    int zzerrstatus;

    /* The stacks and their tools:
       `zzss': related to states.
       `zzvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow zzoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    zztype_int16 zzssa[YYINITDEPTH];
    zztype_int16 *zzss;
    zztype_int16 *zzssp;

    /* The semantic value stack.  */
    YYSTYPE zzvsa[YYINITDEPTH];
    YYSTYPE *zzvs;
    YYSTYPE *zzvsp;

    YYSIZE_T zzstacksize;

  int zzn;
  int zzresult;
  /* Lookahead token as an internal (translated) token number.  */
  int zztoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE zzval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char zzmsgbuf[128];
  char *zzmsg = zzmsgbuf;
  YYSIZE_T zzmsg_alloc = sizeof zzmsgbuf;
#endif

#define YYPOPSTACK(N)   (zzvsp -= (N), zzssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int zzlen = 0;

  zztoken = 0;
  zzss = zzssa;
  zzvs = zzvsa;
  zzstacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  zzstate = 0;
  zzerrstatus = 0;
  zznerrs = 0;
  zzchar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  zzssp = zzss;
  zzvsp = zzvs;

  goto zzsetstate;

/*------------------------------------------------------------.
| zznewstate -- Push a new state, which is found in zzstate.  |
`------------------------------------------------------------*/
 zznewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  zzssp++;

 zzsetstate:
  *zzssp = zzstate;

  if (zzss + zzstacksize - 1 <= zzssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T zzsize = zzssp - zzss + 1;

#ifdef zzoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *zzvs1 = zzvs;
	zztype_int16 *zzss1 = zzss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if zzoverflow is a macro.  */
	zzoverflow (YY_("memory exhausted"),
		    &zzss1, zzsize * sizeof (*zzssp),
		    &zzvs1, zzsize * sizeof (*zzvsp),
		    &zzstacksize);

	zzss = zzss1;
	zzvs = zzvs1;
      }
#else /* no zzoverflow */
# ifndef YYSTACK_RELOCATE
      goto zzexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= zzstacksize)
	goto zzexhaustedlab;
      zzstacksize *= 2;
      if (YYMAXDEPTH < zzstacksize)
	zzstacksize = YYMAXDEPTH;

      {
	zztype_int16 *zzss1 = zzss;
	union zzalloc *zzptr =
	  (union zzalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (zzstacksize));
	if (! zzptr)
	  goto zzexhaustedlab;
	YYSTACK_RELOCATE (zzss_alloc, zzss);
	YYSTACK_RELOCATE (zzvs_alloc, zzvs);
#  undef YYSTACK_RELOCATE
	if (zzss1 != zzssa)
	  YYSTACK_FREE (zzss1);
      }
# endif
#endif /* no zzoverflow */

      zzssp = zzss + zzsize - 1;
      zzvsp = zzvs + zzsize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) zzstacksize));

      if (zzss + zzstacksize - 1 <= zzssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", zzstate));

  if (zzstate == YYFINAL)
    YYACCEPT;

  goto zzbackup;

/*-----------.
| zzbackup.  |
`-----------*/
zzbackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  zzn = zzpact[zzstate];
  if (zzn == YYPACT_NINF)
    goto zzdefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (zzchar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      zzchar = YYLEX;
    }

  if (zzchar <= YYEOF)
    {
      zzchar = zztoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      zztoken = YYTRANSLATE (zzchar);
      YY_SYMBOL_PRINT ("Next token is", zztoken, &zzlval, &zzlloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  zzn += zztoken;
  if (zzn < 0 || YYLAST < zzn || zzcheck[zzn] != zztoken)
    goto zzdefault;
  zzn = zztable[zzn];
  if (zzn <= 0)
    {
      if (zzn == 0 || zzn == YYTABLE_NINF)
	goto zzerrlab;
      zzn = -zzn;
      goto zzreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (zzerrstatus)
    zzerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", zztoken, &zzlval, &zzlloc);

  /* Discard the shifted token.  */
  zzchar = YYEMPTY;

  zzstate = zzn;
  *++zzvsp = zzlval;

  goto zznewstate;


/*-----------------------------------------------------------.
| zzdefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
zzdefault:
  zzn = zzdefact[zzstate];
  if (zzn == 0)
    goto zzerrlab;
  goto zzreduce;


/*-----------------------------.
| zzreduce -- Do a reduction.  |
`-----------------------------*/
zzreduce:
  /* zzn is the number of a rule to reduce with.  */
  zzlen = zzr2[zzn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  zzval = zzvsp[1-zzlen];


  YY_REDUCE_PRINT (zzn);
  switch (zzn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 426 "macroy.y"
    {return_function(0);}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 450 "macroy.y"
    { start_global((zzvsp[(2) - (2)].str)); push("0",PUSH_NUMBER); 
						pop((zzvsp[(2) - (2)].str),0); end_global((zzvsp[(2) - (2)].str));free((zzvsp[(2) - (2)].str)); }
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 452 "macroy.y"
    { start_global((zzvsp[(2) - (3)].str));}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 453 "macroy.y"
    { pop((zzvsp[(2) - (5)].str),0); end_global((zzvsp[(2) - (5)].str));free((zzvsp[(2) - (5)].str)); }
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 456 "macroy.y"
    { push((zzvsp[(2) - (2)].str),PUSH_STRING); 
					   call("import",1); pop((zzvsp[(2) - (2)].str),0); free((zzvsp[(2) - (2)].str)); }
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 460 "macroy.y"
    { push((zzvsp[(2) - (2)].str),PUSH_STRING);call("export",1); 
						pop(NULL,0);free((zzvsp[(2) - (2)].str)); }
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 464 "macroy.y"
    { end_function(NULL);}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 466 "macroy.y"
    { extern_command((zzvsp[(3) - (3)].str),NULL); end_function(NULL); free((zzvsp[(3) - (3)].str));}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 469 "macroy.y"
    { extern_command((zzvsp[(3) - (4)].str),(zzvsp[(4) - (4)].str)); end_function(NULL);free((zzvsp[(3) - (4)].str));free((zzvsp[(4) - (4)].str));}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 472 "macroy.y"
    { begin_function((zzvsp[(2) - (2)].str),0,0,0); free((zzvsp[(2) - (2)].str)); }
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 475 "macroy.y"
    { include((zzvsp[(2) - (2)].str)); free((zzvsp[(2) - (2)].str));}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 476 "macroy.y"
    { include((zzvsp[(2) - (2)].str)); free((zzvsp[(2) - (2)].str));}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 479 "macroy.y"
    { (zzval.str) = (zzvsp[(2) - (2)].str); }
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 487 "macroy.y"
    { argument_count(-1); }
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 488 "macroy.y"
    { argument_count(0);  }
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 489 "macroy.y"
    { argument_count((zzvsp[(2) - (3)].num)); }
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 492 "macroy.y"
    { begin_function((zzvsp[(2) - (2)].str),0,1,0); free((zzvsp[(2) - (2)].str));}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 493 "macroy.y"
    { begin_function((zzvsp[(2) - (2)].str),1,1,0); free((zzvsp[(2) - (2)].str));}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 494 "macroy.y"
    { begin_function((zzvsp[(2) - (2)].str),1,1,1); free((zzvsp[(2) - (2)].str));}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 498 "macroy.y"
    { 
						call("list",(zzvsp[(2) - (2)].num));
						pop(".super",0);
						}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 504 "macroy.y"
    { (zzval.num) = 1; }
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 505 "macroy.y"
    { (zzval.num) = (zzvsp[(1) - (3)].num) + 1; }
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 511 "macroy.y"
    { (zzval.num) = 1;      }
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 512 "macroy.y"
    { (zzval.num) = (zzvsp[(1) - (3)].num) + 1; }
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 515 "macroy.y"
    { param((zzvsp[(1) - (1)].str),NULL); free((zzvsp[(1) - (1)].str)); }
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 516 "macroy.y"
    { param((zzvsp[(1) - (3)].str),(zzvsp[(3) - (3)].str)); free((zzvsp[(1) - (3)].str));free((zzvsp[(3) - (3)].str));}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 519 "macroy.y"
    { end_function((zzvsp[(2) - (2)].str));free((zzvsp[(2) - (2)].str)); }
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 529 "macroy.y"
    { pop(NULL,0); }
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 531 "macroy.y"
    { call((zzvsp[(1) - (1)].str),0);pop(NULL,0);free((zzvsp[(1) - (1)].str));}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 534 "macroy.y"
    { return_function(0); }
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 535 "macroy.y"
    { return_function(1); }
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 539 "macroy.y"
    { pop((zzvsp[(1) - (3)].str),0);free((zzvsp[(1) - (3)].str)); }
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 541 "macroy.y"
    { 
											   pop((zzvsp[(1) - (6)].str),(zzvsp[(3) - (6)].num));
											   free((zzvsp[(1) - (6)].str));
											 }
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 545 "macroy.y"
    { push((zzvsp[(3) - (4)].str),PUSH_STRING); }
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 546 "macroy.y"
    { 
											   pop((zzvsp[(1) - (6)].str),1);
											   free((zzvsp[(1) - (6)].str));
											   free((zzvsp[(3) - (6)].str));
											 }
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 551 "macroy.y"
    { push((zzvsp[(3) - (4)].str),PUSH_NUMBER); }
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 552 "macroy.y"
    { 
											   pop((zzvsp[(1) - (6)].str),1);
											   free((zzvsp[(1) - (6)].str));
											   free((zzvsp[(3) - (6)].str));
											 }
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 573 "macroy.y"
    { begin_loop((zzvsp[(2) - (4)].str)); }
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 575 "macroy.y"
    { end_loop();     }
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 580 "macroy.y"
    { call(".push.dict",1);pop(NULL,0); }
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 582 "macroy.y"
    { call(".pop.dict",0);pop(NULL,0);  }
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 587 "macroy.y"
    { begin_when(); }
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 589 "macroy.y"
    { end_when(); }
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 595 "macroy.y"
    { begin_selection(); }
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 596 "macroy.y"
    { end_selection(); }
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 600 "macroy.y"
    { begin_case();    }
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 603 "macroy.y"
    { end_case();      }
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 610 "macroy.y"
    { begin_choice((zzvsp[(1) - (2)].num));  }
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 611 "macroy.y"
    { end_choice();    }
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 621 "macroy.y"
    { begin_repeat(); }
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 623 "macroy.y"
    { end_until();    }
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 628 "macroy.y"
    { pop((zzvsp[(2) - (4)].str),0); }
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 629 "macroy.y"
    { begin_for((zzvsp[(2) - (9)].str),(zzvsp[(8) - (9)].num)); }
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 631 "macroy.y"
    { end_for((zzvsp[(2) - (13)].str)); free((zzvsp[(2) - (13)].str)); }
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 634 "macroy.y"
    { (zzval.num) = 0 ; }
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 635 "macroy.y"
    { (zzval.num) = 1;  }
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 640 "macroy.y"
    { begin_while(); }
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 641 "macroy.y"
    { do_while();    }
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 643 "macroy.y"
    { end_while() ;  }
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 648 "macroy.y"
    { begin_if();    }
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 653 "macroy.y"
    { end_if();      }
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 654 "macroy.y"
    { else_if(); }
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 655 "macroy.y"
    { else_if();}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 656 "macroy.y"
    { begin_if();    }
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 658 "macroy.y"
    { end_if();      }
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 663 "macroy.y"
    { call("definition",(zzvsp[(2) - (3)].num));  }
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 664 "macroy.y"
    { call("definition",1+(zzvsp[(4) - (5)].num));}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 665 "macroy.y"
    { call("definition",0);   }
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 669 "macroy.y"
    { call((zzvsp[(1) - (4)].str),(zzvsp[(3) - (4)].num));free((zzvsp[(1) - (4)].str)); }
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 670 "macroy.y"
    { call((zzvsp[(1) - (4)].str),(zzvsp[(3) - (4)].num));free((zzvsp[(1) - (4)].str)); }
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 673 "macroy.y"
    { call("[]",(zzvsp[(3) - (4)].num)+1);}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 674 "macroy.y"
    { push((zzvsp[(3) - (3)].str),PUSH_STRING);
										 	call("[]",2);
										 	free((zzvsp[(3) - (3)].str));
										 	}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 678 "macroy.y"
    { push((zzvsp[(3) - (3)].str),PUSH_NUMBER);
										 	call("[]",2);
										 	free((zzvsp[(3) - (3)].str));
										 	}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 682 "macroy.y"
    { 
														push((zzvsp[(1) - (6)].str),PUSH_IDENT);
														push((zzvsp[(3) - (6)].str),PUSH_STRING);
														  call("method",(zzvsp[(5) - (6)].num)+2);
														  free((zzvsp[(1) - (6)].str));
														  free((zzvsp[(3) - (6)].str));
														 }
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 689 "macroy.y"
    { 
														push((zzvsp[(1) - (6)].str),PUSH_IDENT);
														push((zzvsp[(3) - (6)].str),PUSH_STRING);
														call("method",(zzvsp[(5) - (6)].num)+2);
														free((zzvsp[(1) - (6)].str));
														free((zzvsp[(3) - (6)].str));
														}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 700 "macroy.y"
    { push((zzvsp[(1) - (2)].str),PUSH_STRING); 
							  push((zzvsp[(2) - (2)].str),PUSH_STRING);
							  call("inline",2);
							  free((zzvsp[(1) - (2)].str));free((zzvsp[(2) - (2)].str));
							 }
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 710 "macroy.y"
    { (zzval.num) = 0; }
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 714 "macroy.y"
    { (zzval.num) = 1;      }
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 715 "macroy.y"
    { (zzval.num) = (zzvsp[(3) - (3)].num) + 1; }
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 721 "macroy.y"
    { push((zzvsp[(1) - (1)].str),PUSH_STRING); }
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 721 "macroy.y"
    { free((zzvsp[(1) - (4)].str)); }
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 722 "macroy.y"
    { push((zzvsp[(1) - (1)].str),PUSH_STRING); }
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 722 "macroy.y"
    { free((zzvsp[(1) - (4)].str)); }
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 725 "macroy.y"
    { (zzval.num) = 2;      }
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 726 "macroy.y"
    { (zzval.num) = 3;      }
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 727 "macroy.y"
    { (zzval.num) = (zzvsp[(3) - (3)].num) + 2; }
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 728 "macroy.y"
    { (zzval.num) = (zzvsp[(3) - (3)].num) + 1; }
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 731 "macroy.y"
    { (zzval.num) = 2;      }
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 732 "macroy.y"
    { (zzval.num) = (zzvsp[(1) - (2)].num) + 1; }
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 735 "macroy.y"
    { call("_matrix",(zzvsp[(1) - (1)].num));     }
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 738 "macroy.y"
    { call("_vector",(zzvsp[(2) - (3)].num)); }
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 740 "macroy.y"
    { call("list",(zzvsp[(2) - (3)].num));    }
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 743 "macroy.y"
    { push((zzvsp[(1) - (1)].str),PUSH_NUMBER); free((zzvsp[(1) - (1)].str));}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 744 "macroy.y"
    { push((zzvsp[(2) - (2)].str),PUSH_NEGATIVE);free((zzvsp[(2) - (2)].str)); }
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 747 "macroy.y"
    { push((zzvsp[(1) - (1)].str),PUSH_IDENT);  free((zzvsp[(1) - (1)].str));}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 748 "macroy.y"
    { push((zzvsp[(1) - (1)].str),PUSH_STRING); free((zzvsp[(1) - (1)].str));}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 749 "macroy.y"
    { push((zzvsp[(1) - (2)].str),PUSH_DATE);push((zzvsp[(2) - (2)].str),PUSH_TIME);
									  call("+",2);free((zzvsp[(1) - (2)].str));free((zzvsp[(2) - (2)].str));}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 751 "macroy.y"
    { push((zzvsp[(1) - (1)].str),PUSH_DATE);   free((zzvsp[(1) - (1)].str));}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 752 "macroy.y"
    { push((zzvsp[(1) - (1)].str),PUSH_TIME);   free((zzvsp[(1) - (1)].str));}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 758 "macroy.y"
    { push(NULL,PUSH_NIL); }
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 759 "macroy.y"
    { call("neg",1); }
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 768 "macroy.y"
    { call("^",2); }
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 772 "macroy.y"
    { call("*",2); }
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 773 "macroy.y"
    { call("/",2); }
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 777 "macroy.y"
    { call("+",2); }
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 778 "macroy.y"
    { call("-",2); }
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 779 "macroy.y"
    { call("&",2); }
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 783 "macroy.y"
    { call(">",2); }
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 784 "macroy.y"
    { call("=",2); }
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 785 "macroy.y"
    { call("<",2); }
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 786 "macroy.y"
    { call(">=",2); }
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 787 "macroy.y"
    { call("<=",2); }
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 788 "macroy.y"
    { call("<>",2); }
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 789 "macroy.y"
    { call("in",2); }
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 790 "macroy.y"
    { call("in",2); call("not",1);}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 791 "macroy.y"
    { call("not",1); }
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 795 "macroy.y"
    { call("and",2); }
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 799 "macroy.y"
    { call("or",2); }
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 806 "macroy.y"
    { (zzval.str) = strdup(">"); }
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 807 "macroy.y"
    { (zzval.str) = strdup("="); }
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 808 "macroy.y"
    { (zzval.str) = strdup("<"); }
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 809 "macroy.y"
    { (zzval.str) = strdup(">=");}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 810 "macroy.y"
    { (zzval.str) = strdup("<=");}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 811 "macroy.y"
    { (zzval.str) = strdup("<>");}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 812 "macroy.y"
    { (zzval.str) = strdup("in");}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 813 "macroy.y"
    { (zzval.str) = strdup("not");}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 814 "macroy.y"
    { (zzval.str) = strdup("^");}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 815 "macroy.y"
    { (zzval.str) = strdup("*");}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 816 "macroy.y"
    { (zzval.str) = strdup("/");}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 817 "macroy.y"
    { (zzval.str) = strdup("+");}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 818 "macroy.y"
    { (zzval.str) = strdup("-");}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 819 "macroy.y"
    { (zzval.str) = strdup("&");}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 820 "macroy.y"
    { (zzval.str) = strdup("and");}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 821 "macroy.y"
    { (zzval.str) = strdup("or");}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 822 "macroy.y"
    { (zzval.str) = strdup("[]"); }
    break;



/* Line 1455 of yacc.c  */
#line 3123 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", zzr1[zzn], &zzval, &zzloc);

  YYPOPSTACK (zzlen);
  zzlen = 0;
  YY_STACK_PRINT (zzss, zzssp);

  *++zzvsp = zzval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  zzn = zzr1[zzn];

  zzstate = zzpgoto[zzn - YYNTOKENS] + *zzssp;
  if (0 <= zzstate && zzstate <= YYLAST && zzcheck[zzstate] == *zzssp)
    zzstate = zztable[zzstate];
  else
    zzstate = zzdefgoto[zzn - YYNTOKENS];

  goto zznewstate;


/*------------------------------------.
| zzerrlab -- here on detecting error |
`------------------------------------*/
zzerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!zzerrstatus)
    {
      ++zznerrs;
#if ! YYERROR_VERBOSE
      zzerror (YY_("syntax error"));
#else
      {
	YYSIZE_T zzsize = zzsyntax_error (0, zzstate, zzchar);
	if (zzmsg_alloc < zzsize && zzmsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T zzalloc = 2 * zzsize;
	    if (! (zzsize <= zzalloc && zzalloc <= YYSTACK_ALLOC_MAXIMUM))
	      zzalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (zzmsg != zzmsgbuf)
	      YYSTACK_FREE (zzmsg);
	    zzmsg = (char *) YYSTACK_ALLOC (zzalloc);
	    if (zzmsg)
	      zzmsg_alloc = zzalloc;
	    else
	      {
		zzmsg = zzmsgbuf;
		zzmsg_alloc = sizeof zzmsgbuf;
	      }
	  }

	if (0 < zzsize && zzsize <= zzmsg_alloc)
	  {
	    (void) zzsyntax_error (zzmsg, zzstate, zzchar);
	    zzerror (zzmsg);
	  }
	else
	  {
	    zzerror (YY_("syntax error"));
	    if (zzsize != 0)
	      goto zzexhaustedlab;
	  }
      }
#endif
    }



  if (zzerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (zzchar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (zzchar == YYEOF)
	    YYABORT;
	}
      else
	{
	  zzdestruct ("Error: discarding",
		      zztoken, &zzlval);
	  zzchar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto zzerrlab1;


/*---------------------------------------------------.
| zzerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
zzerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label zzerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto zzerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (zzlen);
  zzlen = 0;
  YY_STACK_PRINT (zzss, zzssp);
  zzstate = *zzssp;
  goto zzerrlab1;


/*-------------------------------------------------------------.
| zzerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
zzerrlab1:
  zzerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      zzn = zzpact[zzstate];
      if (zzn != YYPACT_NINF)
	{
	  zzn += YYTERROR;
	  if (0 <= zzn && zzn <= YYLAST && zzcheck[zzn] == YYTERROR)
	    {
	      zzn = zztable[zzn];
	      if (0 < zzn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (zzssp == zzss)
	YYABORT;


      zzdestruct ("Error: popping",
		  zzstos[zzstate], zzvsp);
      YYPOPSTACK (1);
      zzstate = *zzssp;
      YY_STACK_PRINT (zzss, zzssp);
    }

  *++zzvsp = zzlval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", zzstos[zzn], zzvsp, zzlsp);

  zzstate = zzn;
  goto zznewstate;


/*-------------------------------------.
| zzacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
zzacceptlab:
  zzresult = 0;
  goto zzreturn;

/*-----------------------------------.
| zzabortlab -- YYABORT comes here.  |
`-----------------------------------*/
zzabortlab:
  zzresult = 1;
  goto zzreturn;

#if !defined(zzoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| zzexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
zzexhaustedlab:
  zzerror (YY_("memory exhausted"));
  zzresult = 2;
  /* Fall through.  */
#endif

zzreturn:
  if (zzchar != YYEMPTY)
     zzdestruct ("Cleanup: discarding lookahead",
		 zztoken, &zzlval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (zzlen);
  YY_STACK_PRINT (zzss, zzssp);
  while (zzssp != zzss)
    {
      zzdestruct ("Cleanup: popping",
		  zzstos[*zzssp], zzvsp);
      YYPOPSTACK (1);
    }
#ifndef zzoverflow
  if (zzss != zzssa)
    YYSTACK_FREE (zzss);
#endif
#if YYERROR_VERBOSE
  if (zzmsg != zzmsgbuf)
    YYSTACK_FREE (zzmsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (zzresult);
}



/* Line 1675 of yacc.c  */
#line 828 "macroy.y"

#include "macrol.c"


